/* Application.c generated by valac 0.56.3, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk/gdk.h>

#define HE_APPLICATION_STYLE_PROVIDER_PRIORITY_PLATFORM (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 1)
#define HE_APPLICATION_STYLE_PROVIDER_PRIORITY_ACCENT (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 2)
#define HE_APPLICATION_STYLE_PROVIDER_PRIORITY_USER_BASE (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 3)
#define HE_APPLICATION_STYLE_PROVIDER_PRIORITY_USER_DARK (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 4)

enum  {
	HE_APPLICATION_0_PROPERTY,
	HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY,
	HE_APPLICATION_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_FOREGROUND_PROPERTY,
	HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY,
	HE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* he_application_properties[HE_APPLICATION_NUM_PROPERTIES];
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeApplicationPrivate {
	HeColorRGBColor default_dark_accent;
	HeColorRGBColor default_light_accent;
	HeColorRGBColor* _default_accent_color;
	HeColorRGBColor* _derived_card_bg;
	gdouble _default_font_weight;
	GtkCssProvider* light;
	GtkCssProvider* dark;
	GtkCssProvider* accent;
	GtkCssProvider* user_base;
	GtkCssProvider* user_dark;
	HeDesktop* desktop;
	HeColorRGBColor* _accent_color;
	HeColorRGBColor* _foreground;
	HeColorRGBColor* _accent_foreground;
};

static gint HeApplication_private_offset;
static gpointer he_application_parent_class = NULL;

static gboolean _he_color_rgb_color_equal (const HeColorRGBColor * s1,
                                    const HeColorRGBColor * s2);
static HeColorRGBColor* he_application_get_derived_card_bg (HeApplication* self);
static void he_application_set_derived_card_bg (HeApplication* self,
                                         HeColorRGBColor* value);
static void he_application_set_accent_color (HeApplication* self,
                                      HeColorRGBColor * value);
static void he_application_set_foreground (HeApplication* self,
                                    HeColorRGBColor * value);
static void he_application_set_accent_foreground (HeApplication* self,
                                           HeColorRGBColor * value);
static void he_application_update_style_providers (HeApplication* self);
static void he_application_style_provider_set_enabled (HeApplication* self,
                                                GtkCssProvider* provider,
                                                gboolean enabled,
                                                gint priority);
static void he_application_init_style_providers (HeApplication* self);
static void _he_application_update_style_providers_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void he_application_init_app_providers (HeApplication* self);
static void he_application_init_provider_from_file (HeApplication* self,
                                             GtkCssProvider* provider,
                                             GFile* file);
static void he_application_real_startup (GApplication* base);
VALA_EXTERN void he_init (void);
static void he_application_finalize (GObject * obj);
static GType he_application_get_type_once (void);
static void _vala_he_application_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_application_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

VALA_EXTERN const HeColorRGBColor HE_COLOR_CARD_BLACK;
VALA_EXTERN const HeColorRGBColor HE_COLOR_SOFT_CARD_BLACK;
VALA_EXTERN const HeColorRGBColor HE_COLOR_HARSH_CARD_BLACK;

static inline gpointer
he_application_get_instance_private (HeApplication* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplication_private_offset);
}

HeColorRGBColor*
he_application_get_default_accent_color (HeApplication* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_accent_color;
	result = _tmp0_;
	return result;
}

static gboolean
_he_color_rgb_color_equal (const HeColorRGBColor * s1,
                           const HeColorRGBColor * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->r != s2->r) {
		return FALSE;
	}
	if (s1->g != s2->g) {
		return FALSE;
	}
	if (s1->b != s2->b) {
		return FALSE;
	}
	return TRUE;
}

static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
	return self ? he_color_rgb_color_dup (self) : NULL;
}

void
he_application_set_default_accent_color (HeApplication* self,
                                         HeColorRGBColor* value)
{
	HeColorRGBColor* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_application_get_default_accent_color (self);
	if (_he_color_rgb_color_equal (value, old_value) != TRUE) {
		HeColorRGBColor* _tmp0_;
		_tmp0_ = _he_color_rgb_color_dup0 (value);
		_he_color_rgb_color_free0 (self->priv->_default_accent_color);
		self->priv->_default_accent_color = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY]);
	}
}

static HeColorRGBColor*
he_application_get_derived_card_bg (HeApplication* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_derived_card_bg;
	result = _tmp0_;
	return result;
}

static void
he_application_set_derived_card_bg (HeApplication* self,
                                    HeColorRGBColor* value)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _he_color_rgb_color_dup0 (value);
	_he_color_rgb_color_free0 (self->priv->_derived_card_bg);
	self->priv->_derived_card_bg = _tmp0_;
}

gdouble
he_application_get_default_font_weight (HeApplication* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_default_font_weight;
	return result;
}

void
he_application_set_default_font_weight (HeApplication* self,
                                        gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = he_application_get_default_font_weight (self);
	if (old_value != value) {
		self->priv->_default_font_weight = value;
		g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY]);
	}
}

void
he_application_get_accent_color (HeApplication* self,
                                 HeColorRGBColor * result)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_accent_color;
	*result = *_tmp0_;
	return;
}

static void
he_application_set_accent_color (HeApplication* self,
                                 HeColorRGBColor * value)
{
	HeColorRGBColor _tmp0_;
	HeColorRGBColor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	_tmp1_ = _he_color_rgb_color_dup0 (&_tmp0_);
	_he_color_rgb_color_free0 (self->priv->_accent_color);
	self->priv->_accent_color = _tmp1_;
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_ACCENT_COLOR_PROPERTY]);
}

void
he_application_get_foreground (HeApplication* self,
                               HeColorRGBColor * result)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_foreground;
	*result = *_tmp0_;
	return;
}

static void
he_application_set_foreground (HeApplication* self,
                               HeColorRGBColor * value)
{
	HeColorRGBColor _tmp0_;
	HeColorRGBColor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	_tmp1_ = _he_color_rgb_color_dup0 (&_tmp0_);
	_he_color_rgb_color_free0 (self->priv->_foreground);
	self->priv->_foreground = _tmp1_;
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_FOREGROUND_PROPERTY]);
}

void
he_application_get_accent_foreground (HeApplication* self,
                                      HeColorRGBColor * result)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_accent_foreground;
	*result = *_tmp0_;
	return;
}

static void
he_application_set_accent_foreground (HeApplication* self,
                                      HeColorRGBColor * value)
{
	HeColorRGBColor _tmp0_;
	HeColorRGBColor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	_tmp1_ = _he_color_rgb_color_dup0 (&_tmp0_);
	_he_color_rgb_color_free0 (self->priv->_accent_foreground);
	self->priv->_accent_foreground = _tmp1_;
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY]);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static void
he_application_update_style_providers (HeApplication* self)
{
	HeColorRGBColor rgb_color = {0};
	gdouble weight = 0.0;
	gboolean is_dark = FALSE;
	HeDesktop* _tmp0_;
	HeDesktopColorScheme _tmp1_;
	HeDesktopColorScheme _tmp2_;
	HeDesktop* _tmp3_;
	HeColorRGBColor* _tmp4_;
	HeColorRGBColor* _tmp5_;
	HeDesktop* _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	HeColorCAM16Color cam16_color = {0};
	HeColorRGBColor _tmp22_;
	HeColorXYZColor _tmp23_ = {0};
	HeColorCAM16Color _tmp24_ = {0};
	HeDesktop* _tmp25_;
	HeDesktopDarkModeStrength _tmp26_;
	HeDesktopDarkModeStrength _tmp27_;
	gchar* background_hex = NULL;
	HeColorRGBColor* _tmp34_;
	HeColorRGBColor* _tmp35_;
	HeColorRGBColor* _tmp36_;
	gchar* _tmp37_;
	HeScheme* chosen_scheme = NULL;
	HeColorCAM16Color _tmp38_;
	HeDesktop* _tmp39_;
	HeScheme* _tmp40_;
	HeDesktop* _tmp41_;
	HeDesktopEnsorScheme _tmp42_;
	HeDesktopEnsorScheme _tmp43_;
	const gchar* _tmp68_ = NULL;
	gchar* error_hex = NULL;
	gchar* _tmp69_;
	const gchar* _tmp70_ = NULL;
	gchar* on_error_hex = NULL;
	gchar* _tmp71_;
	const gchar* _tmp72_ = NULL;
	gchar* error_container_hex = NULL;
	gchar* _tmp73_;
	const gchar* _tmp74_ = NULL;
	gchar* on_error_container_hex = NULL;
	gchar* _tmp75_;
	HeColorHCTColor _tmp76_ = {0};
	HeColorHCTColor meson_red_hct = {0};
	gchar* meson_red_hex = NULL;
	HeColorHCTColor _tmp87_;
	HeColorHCTColor _tmp88_;
	HeColorHCTColor _tmp89_;
	gchar* _tmp90_;
	HeColorHCTColor _tmp91_ = {0};
	HeColorHCTColor lepton_orange_hct = {0};
	gchar* lepton_orange_hex = NULL;
	HeColorHCTColor _tmp102_;
	HeColorHCTColor _tmp103_;
	HeColorHCTColor _tmp104_;
	gchar* _tmp105_;
	HeColorHCTColor _tmp106_ = {0};
	HeColorHCTColor electron_yellow_hct = {0};
	gchar* electron_yellow_hex = NULL;
	HeColorHCTColor _tmp117_;
	HeColorHCTColor _tmp118_;
	HeColorHCTColor _tmp119_;
	gchar* _tmp120_;
	HeColorHCTColor _tmp121_ = {0};
	HeColorHCTColor muon_green_hct = {0};
	gchar* muon_green_hex = NULL;
	HeColorHCTColor _tmp132_;
	HeColorHCTColor _tmp133_;
	HeColorHCTColor _tmp134_;
	gchar* _tmp135_;
	HeColorHCTColor _tmp136_ = {0};
	HeColorHCTColor baryon_mint_hct = {0};
	gchar* baryon_mint_hex = NULL;
	HeColorHCTColor _tmp147_;
	HeColorHCTColor _tmp148_;
	HeColorHCTColor _tmp149_;
	gchar* _tmp150_;
	HeColorHCTColor _tmp151_ = {0};
	HeColorHCTColor proton_blue_hct = {0};
	gchar* proton_blue_hex = NULL;
	HeColorHCTColor _tmp162_;
	HeColorHCTColor _tmp163_;
	HeColorHCTColor _tmp164_;
	gchar* _tmp165_;
	HeColorHCTColor _tmp166_ = {0};
	HeColorHCTColor photon_indigo_hct = {0};
	gchar* photon_indigo_hex = NULL;
	HeColorHCTColor _tmp177_;
	HeColorHCTColor _tmp178_;
	HeColorHCTColor _tmp179_;
	gchar* _tmp180_;
	HeColorHCTColor _tmp181_ = {0};
	HeColorHCTColor tau_purple_hct = {0};
	gchar* tau_purple_hex = NULL;
	HeColorHCTColor _tmp192_;
	HeColorHCTColor _tmp193_;
	HeColorHCTColor _tmp194_;
	gchar* _tmp195_;
	HeColorHCTColor _tmp196_ = {0};
	HeColorHCTColor fermion_pink_hct = {0};
	gchar* fermion_pink_hex = NULL;
	HeColorHCTColor _tmp207_;
	HeColorHCTColor _tmp208_;
	HeColorHCTColor _tmp209_;
	gchar* _tmp210_;
	HeColorHCTColor _tmp211_ = {0};
	HeColorHCTColor gluon_brown_hct = {0};
	gchar* gluon_brown_hex = NULL;
	HeColorHCTColor _tmp222_;
	HeColorHCTColor _tmp223_;
	HeColorHCTColor _tmp224_;
	gchar* _tmp225_;
	gchar* css = NULL;
	gchar* _tmp226_;
	HeDesktop* _tmp227_;
	HeDesktopColorScheme _tmp228_;
	HeDesktopColorScheme _tmp229_;
	const gchar* _tmp578_;
	const gchar* _tmp579_;
	const gchar* _tmp580_;
	const gchar* _tmp581_;
	const gchar* _tmp582_;
	const gchar* _tmp583_;
	const gchar* _tmp584_;
	const gchar* _tmp585_;
	const gchar* _tmp586_;
	const gchar* _tmp587_;
	const gchar* _tmp588_;
	const gchar* _tmp589_;
	const gchar* _tmp590_;
	const gchar* _tmp591_;
	const gchar* _tmp592_;
	const gchar* _tmp593_;
	const gchar* _tmp594_;
	const gchar* _tmp595_;
	const gchar* _tmp596_;
	const gchar* _tmp597_;
	const gchar* _tmp598_;
	gchar* _tmp599_;
	gchar* _tmp600_;
	gchar* _tmp601_;
	HeDesktop* _tmp602_;
	gdouble _tmp603_;
	gdouble _tmp604_;
	GtkCssProvider* _tmp695_;
	const gchar* _tmp696_;
	guint8* _tmp697_;
	gint _tmp697__length1;
	gint _tmp698_ = 0;
	guint8* _tmp699_;
	gint _tmp699__length1;
	GtkCssProvider* _tmp700_;
	GtkCssProvider* _tmp701_;
	GtkCssProvider* _tmp702_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->desktop;
	_tmp1_ = he_desktop_get_prefers_color_scheme (_tmp0_);
	_tmp2_ = _tmp1_;
	is_dark = HE_DESKTOP_COLOR_SCHEME_DARK == _tmp2_;
	_tmp3_ = self->priv->desktop;
	_tmp4_ = he_desktop_get_accent_color (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		HeColorRGBColor* _tmp6_;
		_tmp6_ = self->priv->_default_accent_color;
		if (_tmp6_ != NULL) {
			HeColorRGBColor* _tmp7_;
			_tmp7_ = self->priv->_default_accent_color;
			rgb_color = *_tmp7_;
		} else {
			HeColorRGBColor _tmp8_ = {0};
			if (is_dark) {
				HeColorRGBColor _tmp9_;
				_tmp9_ = self->priv->default_dark_accent;
				_tmp8_ = _tmp9_;
			} else {
				HeColorRGBColor _tmp10_;
				_tmp10_ = self->priv->default_light_accent;
				_tmp8_ = _tmp10_;
			}
			rgb_color = _tmp8_;
		}
	} else {
		HeDesktop* _tmp11_;
		HeColorRGBColor* _tmp12_;
		HeColorRGBColor* _tmp13_;
		_tmp11_ = self->priv->desktop;
		_tmp12_ = he_desktop_get_accent_color (_tmp11_);
		_tmp13_ = _tmp12_;
		rgb_color = *_tmp13_;
	}
	_tmp14_ = self->priv->desktop;
	_tmp15_ = he_desktop_get_font_weight (_tmp14_);
	_tmp16_ = _tmp15_;
	if (_tmp16_ == 0.0) {
		gdouble _tmp17_;
		_tmp17_ = self->priv->_default_font_weight;
		if (_tmp17_ != 0.0) {
			gdouble _tmp18_;
			_tmp18_ = self->priv->_default_font_weight;
			weight = 400 * _tmp18_;
		} else {
			weight = 400 * 1.0;
		}
	} else {
		HeDesktop* _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		_tmp19_ = self->priv->desktop;
		_tmp20_ = he_desktop_get_font_weight (_tmp19_);
		_tmp21_ = _tmp20_;
		weight = 400 * _tmp21_;
	}
	_tmp22_ = rgb_color;
	he_color_rgb_to_xyz (&_tmp22_, &_tmp23_);
	he_color_xyz_to_cam16 (&_tmp23_, &_tmp24_);
	cam16_color = _tmp24_;
	_tmp25_ = self->priv->desktop;
	_tmp26_ = he_desktop_get_dark_mode_strength (_tmp25_);
	_tmp27_ = _tmp26_;
	if (HE_DESKTOP_DARK_MODE_STRENGTH_MEDIUM == _tmp27_) {
		he_application_set_derived_card_bg (self, &HE_COLOR_CARD_BLACK);
	} else {
		HeDesktop* _tmp28_;
		HeDesktopDarkModeStrength _tmp29_;
		HeDesktopDarkModeStrength _tmp30_;
		_tmp28_ = self->priv->desktop;
		_tmp29_ = he_desktop_get_dark_mode_strength (_tmp28_);
		_tmp30_ = _tmp29_;
		if (HE_DESKTOP_DARK_MODE_STRENGTH_SOFT == _tmp30_) {
			he_application_set_derived_card_bg (self, &HE_COLOR_SOFT_CARD_BLACK);
		} else {
			HeDesktop* _tmp31_;
			HeDesktopDarkModeStrength _tmp32_;
			HeDesktopDarkModeStrength _tmp33_;
			_tmp31_ = self->priv->desktop;
			_tmp32_ = he_desktop_get_dark_mode_strength (_tmp31_);
			_tmp33_ = _tmp32_;
			if (HE_DESKTOP_DARK_MODE_STRENGTH_HARSH == _tmp33_) {
				he_application_set_derived_card_bg (self, &HE_COLOR_HARSH_CARD_BLACK);
			}
		}
	}
	_tmp34_ = self->priv->_derived_card_bg;
	_tmp35_ = self->priv->_derived_card_bg;
	_tmp36_ = self->priv->_derived_card_bg;
	_tmp37_ = he_color_hexcode ((*_tmp34_).r, (*_tmp35_).g, (*_tmp36_).b);
	background_hex = _tmp37_;
	_tmp38_ = cam16_color;
	_tmp39_ = self->priv->desktop;
	_tmp40_ = he_scheme_new (&_tmp38_, _tmp39_);
	chosen_scheme = _tmp40_;
	_tmp41_ = self->priv->desktop;
	_tmp42_ = he_desktop_get_ensor_scheme (_tmp41_);
	_tmp43_ = _tmp42_;
	if (HE_DESKTOP_ENSOR_SCHEME_DEFAULT == _tmp43_) {
		HeColorCAM16Color _tmp44_;
		HeDesktop* _tmp45_;
		HeSchemesDefault* _tmp46_;
		_tmp44_ = cam16_color;
		_tmp45_ = self->priv->desktop;
		_tmp46_ = he_schemes_default_new (&_tmp44_, _tmp45_);
		_g_object_unref0 (chosen_scheme);
		chosen_scheme = (HeScheme*) _tmp46_;
	} else {
		HeDesktop* _tmp47_;
		HeDesktopEnsorScheme _tmp48_;
		HeDesktopEnsorScheme _tmp49_;
		_tmp47_ = self->priv->desktop;
		_tmp48_ = he_desktop_get_ensor_scheme (_tmp47_);
		_tmp49_ = _tmp48_;
		if (HE_DESKTOP_ENSOR_SCHEME_VIBRANT == _tmp49_) {
			HeColorCAM16Color _tmp50_;
			HeDesktop* _tmp51_;
			HeSchemesVibrant* _tmp52_;
			_tmp50_ = cam16_color;
			_tmp51_ = self->priv->desktop;
			_tmp52_ = he_schemes_vibrant_new (&_tmp50_, _tmp51_);
			_g_object_unref0 (chosen_scheme);
			chosen_scheme = (HeScheme*) _tmp52_;
		} else {
			HeDesktop* _tmp53_;
			HeDesktopEnsorScheme _tmp54_;
			HeDesktopEnsorScheme _tmp55_;
			_tmp53_ = self->priv->desktop;
			_tmp54_ = he_desktop_get_ensor_scheme (_tmp53_);
			_tmp55_ = _tmp54_;
			if (HE_DESKTOP_ENSOR_SCHEME_MUTED == _tmp55_) {
				HeColorCAM16Color _tmp56_;
				HeDesktop* _tmp57_;
				HeSchemesMuted* _tmp58_;
				_tmp56_ = cam16_color;
				_tmp57_ = self->priv->desktop;
				_tmp58_ = he_schemes_muted_new (&_tmp56_, _tmp57_);
				_g_object_unref0 (chosen_scheme);
				chosen_scheme = (HeScheme*) _tmp58_;
			} else {
				HeDesktop* _tmp59_;
				HeDesktopEnsorScheme _tmp60_;
				HeDesktopEnsorScheme _tmp61_;
				_tmp59_ = self->priv->desktop;
				_tmp60_ = he_desktop_get_ensor_scheme (_tmp59_);
				_tmp61_ = _tmp60_;
				if (HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC == _tmp61_) {
					HeColorCAM16Color _tmp62_;
					HeDesktop* _tmp63_;
					HeSchemesMonochrome* _tmp64_;
					_tmp62_ = cam16_color;
					_tmp63_ = self->priv->desktop;
					_tmp64_ = he_schemes_monochrome_new (&_tmp62_, _tmp63_);
					_g_object_unref0 (chosen_scheme);
					chosen_scheme = (HeScheme*) _tmp64_;
				} else {
					HeColorCAM16Color _tmp65_;
					HeDesktop* _tmp66_;
					HeSchemesDefault* _tmp67_;
					_tmp65_ = cam16_color;
					_tmp66_ = self->priv->desktop;
					_tmp67_ = he_schemes_default_new (&_tmp65_, _tmp66_);
					_g_object_unref0 (chosen_scheme);
					chosen_scheme = (HeScheme*) _tmp67_;
				}
			}
		}
	}
	if (is_dark) {
		_tmp68_ = "#F2B8B5";
	} else {
		_tmp68_ = "#B3261E";
	}
	_tmp69_ = g_strdup (_tmp68_);
	error_hex = _tmp69_;
	if (is_dark) {
		_tmp70_ = "#601410";
	} else {
		_tmp70_ = "#FFFFFF";
	}
	_tmp71_ = g_strdup (_tmp70_);
	on_error_hex = _tmp71_;
	if (is_dark) {
		_tmp72_ = "#8C1D18";
	} else {
		_tmp72_ = "#F9DEDC";
	}
	_tmp73_ = g_strdup (_tmp72_);
	error_container_hex = _tmp73_;
	if (is_dark) {
		_tmp74_ = "#F9DEDC";
	} else {
		_tmp74_ = "#410E0B";
	}
	_tmp75_ = g_strdup (_tmp74_);
	on_error_container_hex = _tmp75_;
	if (is_dark) {
		HeColorHCTColor _tmp77_ = {0};
		HeColorCAM16Color _tmp78_;
		HeColorCAM16Color _tmp79_;
		HeColorHCTColor _tmp80_ = {0};
		HeColorHCTColor _tmp81_ = {0};
		he_color_from_params (8.0, 85.0, 80.0, &_tmp77_);
		_tmp78_ = cam16_color;
		_tmp79_ = cam16_color;
		he_color_from_params (_tmp78_.h, _tmp79_.c, 80.0, &_tmp80_);
		he_color_hct_blend (&_tmp77_, &_tmp80_, &_tmp81_);
		_tmp76_ = _tmp81_;
	} else {
		HeColorHCTColor _tmp82_ = {0};
		HeColorCAM16Color _tmp83_;
		HeColorCAM16Color _tmp84_;
		HeColorHCTColor _tmp85_ = {0};
		HeColorHCTColor _tmp86_ = {0};
		he_color_from_params (2.0, 49.0, 40.0, &_tmp82_);
		_tmp83_ = cam16_color;
		_tmp84_ = cam16_color;
		he_color_from_params (_tmp83_.h, _tmp84_.c, 40.0, &_tmp85_);
		he_color_hct_blend (&_tmp82_, &_tmp85_, &_tmp86_);
		_tmp76_ = _tmp86_;
	}
	meson_red_hct = _tmp76_;
	_tmp87_ = meson_red_hct;
	_tmp88_ = meson_red_hct;
	_tmp89_ = meson_red_hct;
	_tmp90_ = he_color_hct_to_hex (_tmp87_.h, _tmp88_.c, _tmp89_.t);
	meson_red_hex = _tmp90_;
	if (is_dark) {
		HeColorHCTColor _tmp92_ = {0};
		HeColorCAM16Color _tmp93_;
		HeColorCAM16Color _tmp94_;
		HeColorHCTColor _tmp95_ = {0};
		HeColorHCTColor _tmp96_ = {0};
		he_color_from_params (55.0, 29.0, 80.0, &_tmp92_);
		_tmp93_ = cam16_color;
		_tmp94_ = cam16_color;
		he_color_from_params (_tmp93_.h, _tmp94_.c, 80.0, &_tmp95_);
		he_color_hct_blend (&_tmp92_, &_tmp95_, &_tmp96_);
		_tmp91_ = _tmp96_;
	} else {
		HeColorHCTColor _tmp97_ = {0};
		HeColorCAM16Color _tmp98_;
		HeColorCAM16Color _tmp99_;
		HeColorHCTColor _tmp100_ = {0};
		HeColorHCTColor _tmp101_ = {0};
		he_color_from_params (50.0, 61.0, 40.0, &_tmp97_);
		_tmp98_ = cam16_color;
		_tmp99_ = cam16_color;
		he_color_from_params (_tmp98_.h, _tmp99_.c, 40.0, &_tmp100_);
		he_color_hct_blend (&_tmp97_, &_tmp100_, &_tmp101_);
		_tmp91_ = _tmp101_;
	}
	lepton_orange_hct = _tmp91_;
	_tmp102_ = lepton_orange_hct;
	_tmp103_ = lepton_orange_hct;
	_tmp104_ = lepton_orange_hct;
	_tmp105_ = he_color_hct_to_hex (_tmp102_.h, _tmp103_.c, _tmp104_.t);
	lepton_orange_hex = _tmp105_;
	if (is_dark) {
		HeColorHCTColor _tmp107_ = {0};
		HeColorCAM16Color _tmp108_;
		HeColorCAM16Color _tmp109_;
		HeColorHCTColor _tmp110_ = {0};
		HeColorHCTColor _tmp111_ = {0};
		he_color_from_params (89.0, 37.0, 80.0, &_tmp107_);
		_tmp108_ = cam16_color;
		_tmp109_ = cam16_color;
		he_color_from_params (_tmp108_.h, _tmp109_.c, 80.0, &_tmp110_);
		he_color_hct_blend (&_tmp107_, &_tmp110_, &_tmp111_);
		_tmp106_ = _tmp111_;
	} else {
		HeColorHCTColor _tmp112_ = {0};
		HeColorCAM16Color _tmp113_;
		HeColorCAM16Color _tmp114_;
		HeColorHCTColor _tmp115_ = {0};
		HeColorHCTColor _tmp116_ = {0};
		he_color_from_params (81.0, 55.0, 40.0, &_tmp112_);
		_tmp113_ = cam16_color;
		_tmp114_ = cam16_color;
		he_color_from_params (_tmp113_.h, _tmp114_.c, 40.0, &_tmp115_);
		he_color_hct_blend (&_tmp112_, &_tmp115_, &_tmp116_);
		_tmp106_ = _tmp116_;
	}
	electron_yellow_hct = _tmp106_;
	_tmp117_ = electron_yellow_hct;
	_tmp118_ = electron_yellow_hct;
	_tmp119_ = electron_yellow_hct;
	_tmp120_ = he_color_hct_to_hex (_tmp117_.h, _tmp118_.c, _tmp119_.t);
	electron_yellow_hex = _tmp120_;
	if (is_dark) {
		HeColorHCTColor _tmp122_ = {0};
		HeColorCAM16Color _tmp123_;
		HeColorCAM16Color _tmp124_;
		HeColorHCTColor _tmp125_ = {0};
		HeColorHCTColor _tmp126_ = {0};
		he_color_from_params (152.0, 43.0, 80.0, &_tmp122_);
		_tmp123_ = cam16_color;
		_tmp124_ = cam16_color;
		he_color_from_params (_tmp123_.h, _tmp124_.c, 80.0, &_tmp125_);
		he_color_hct_blend (&_tmp122_, &_tmp125_, &_tmp126_);
		_tmp121_ = _tmp126_;
	} else {
		HeColorHCTColor _tmp127_ = {0};
		HeColorCAM16Color _tmp128_;
		HeColorCAM16Color _tmp129_;
		HeColorHCTColor _tmp130_ = {0};
		HeColorHCTColor _tmp131_ = {0};
		he_color_from_params (147.0, 71.0, 40.0, &_tmp127_);
		_tmp128_ = cam16_color;
		_tmp129_ = cam16_color;
		he_color_from_params (_tmp128_.h, _tmp129_.c, 40.0, &_tmp130_);
		he_color_hct_blend (&_tmp127_, &_tmp130_, &_tmp131_);
		_tmp121_ = _tmp131_;
	}
	muon_green_hct = _tmp121_;
	_tmp132_ = muon_green_hct;
	_tmp133_ = muon_green_hct;
	_tmp134_ = muon_green_hct;
	_tmp135_ = he_color_hct_to_hex (_tmp132_.h, _tmp133_.c, _tmp134_.t);
	muon_green_hex = _tmp135_;
	if (is_dark) {
		HeColorHCTColor _tmp137_ = {0};
		HeColorCAM16Color _tmp138_;
		HeColorCAM16Color _tmp139_;
		HeColorHCTColor _tmp140_ = {0};
		HeColorHCTColor _tmp141_ = {0};
		he_color_from_params (182.0, 25.0, 80.0, &_tmp137_);
		_tmp138_ = cam16_color;
		_tmp139_ = cam16_color;
		he_color_from_params (_tmp138_.h, _tmp139_.c, 80.0, &_tmp140_);
		he_color_hct_blend (&_tmp137_, &_tmp140_, &_tmp141_);
		_tmp136_ = _tmp141_;
	} else {
		HeColorHCTColor _tmp142_ = {0};
		HeColorCAM16Color _tmp143_;
		HeColorCAM16Color _tmp144_;
		HeColorHCTColor _tmp145_ = {0};
		HeColorHCTColor _tmp146_ = {0};
		he_color_from_params (177.0, 42.0, 40.0, &_tmp142_);
		_tmp143_ = cam16_color;
		_tmp144_ = cam16_color;
		he_color_from_params (_tmp143_.h, _tmp144_.c, 40.0, &_tmp145_);
		he_color_hct_blend (&_tmp142_, &_tmp145_, &_tmp146_);
		_tmp136_ = _tmp146_;
	}
	baryon_mint_hct = _tmp136_;
	_tmp147_ = baryon_mint_hct;
	_tmp148_ = baryon_mint_hct;
	_tmp149_ = baryon_mint_hct;
	_tmp150_ = he_color_hct_to_hex (_tmp147_.h, _tmp148_.c, _tmp149_.t);
	baryon_mint_hex = _tmp150_;
	if (is_dark) {
		HeColorHCTColor _tmp152_ = {0};
		HeColorCAM16Color _tmp153_;
		HeColorCAM16Color _tmp154_;
		HeColorHCTColor _tmp155_ = {0};
		HeColorHCTColor _tmp156_ = {0};
		he_color_from_params (233.0, 34.0, 80.0, &_tmp152_);
		_tmp153_ = cam16_color;
		_tmp154_ = cam16_color;
		he_color_from_params (_tmp153_.h, _tmp154_.c, 80.0, &_tmp155_);
		he_color_hct_blend (&_tmp152_, &_tmp155_, &_tmp156_);
		_tmp151_ = _tmp156_;
	} else {
		HeColorHCTColor _tmp157_ = {0};
		HeColorCAM16Color _tmp158_;
		HeColorCAM16Color _tmp159_;
		HeColorHCTColor _tmp160_ = {0};
		HeColorHCTColor _tmp161_ = {0};
		he_color_from_params (240.0, 53.0, 40.0, &_tmp157_);
		_tmp158_ = cam16_color;
		_tmp159_ = cam16_color;
		he_color_from_params (_tmp158_.h, _tmp159_.c, 40.0, &_tmp160_);
		he_color_hct_blend (&_tmp157_, &_tmp160_, &_tmp161_);
		_tmp151_ = _tmp161_;
	}
	proton_blue_hct = _tmp151_;
	_tmp162_ = proton_blue_hct;
	_tmp163_ = proton_blue_hct;
	_tmp164_ = proton_blue_hct;
	_tmp165_ = he_color_hct_to_hex (_tmp162_.h, _tmp163_.c, _tmp164_.t);
	proton_blue_hex = _tmp165_;
	if (is_dark) {
		HeColorHCTColor _tmp167_ = {0};
		HeColorCAM16Color _tmp168_;
		HeColorCAM16Color _tmp169_;
		HeColorHCTColor _tmp170_ = {0};
		HeColorHCTColor _tmp171_ = {0};
		he_color_from_params (291.0, 67.0, 80.0, &_tmp167_);
		_tmp168_ = cam16_color;
		_tmp169_ = cam16_color;
		he_color_from_params (_tmp168_.h, _tmp169_.c, 80.0, &_tmp170_);
		he_color_hct_blend (&_tmp167_, &_tmp170_, &_tmp171_);
		_tmp166_ = _tmp171_;
	} else {
		HeColorHCTColor _tmp172_ = {0};
		HeColorCAM16Color _tmp173_;
		HeColorCAM16Color _tmp174_;
		HeColorHCTColor _tmp175_ = {0};
		HeColorHCTColor _tmp176_ = {0};
		he_color_from_params (288.0, 84.0, 40.0, &_tmp172_);
		_tmp173_ = cam16_color;
		_tmp174_ = cam16_color;
		he_color_from_params (_tmp173_.h, _tmp174_.c, 40.0, &_tmp175_);
		he_color_hct_blend (&_tmp172_, &_tmp175_, &_tmp176_);
		_tmp166_ = _tmp176_;
	}
	photon_indigo_hct = _tmp166_;
	_tmp177_ = photon_indigo_hct;
	_tmp178_ = photon_indigo_hct;
	_tmp179_ = photon_indigo_hct;
	_tmp180_ = he_color_hct_to_hex (_tmp177_.h, _tmp178_.c, _tmp179_.t);
	photon_indigo_hex = _tmp180_;
	if (is_dark) {
		HeColorHCTColor _tmp182_ = {0};
		HeColorCAM16Color _tmp183_;
		HeColorCAM16Color _tmp184_;
		HeColorHCTColor _tmp185_ = {0};
		HeColorHCTColor _tmp186_ = {0};
		he_color_from_params (309.0, 34.0, 80.0, &_tmp182_);
		_tmp183_ = cam16_color;
		_tmp184_ = cam16_color;
		he_color_from_params (_tmp183_.h, _tmp184_.c, 80.0, &_tmp185_);
		he_color_hct_blend (&_tmp182_, &_tmp185_, &_tmp186_);
		_tmp181_ = _tmp186_;
	} else {
		HeColorHCTColor _tmp187_ = {0};
		HeColorCAM16Color _tmp188_;
		HeColorCAM16Color _tmp189_;
		HeColorHCTColor _tmp190_ = {0};
		HeColorHCTColor _tmp191_ = {0};
		he_color_from_params (311.0, 57.0, 40.0, &_tmp187_);
		_tmp188_ = cam16_color;
		_tmp189_ = cam16_color;
		he_color_from_params (_tmp188_.h, _tmp189_.c, 40.0, &_tmp190_);
		he_color_hct_blend (&_tmp187_, &_tmp190_, &_tmp191_);
		_tmp181_ = _tmp191_;
	}
	tau_purple_hct = _tmp181_;
	_tmp192_ = tau_purple_hct;
	_tmp193_ = tau_purple_hct;
	_tmp194_ = tau_purple_hct;
	_tmp195_ = he_color_hct_to_hex (_tmp192_.h, _tmp193_.c, _tmp194_.t);
	tau_purple_hex = _tmp195_;
	if (is_dark) {
		HeColorHCTColor _tmp197_ = {0};
		HeColorCAM16Color _tmp198_;
		HeColorCAM16Color _tmp199_;
		HeColorHCTColor _tmp200_ = {0};
		HeColorHCTColor _tmp201_ = {0};
		he_color_from_params (337.0, 34.0, 80.0, &_tmp197_);
		_tmp198_ = cam16_color;
		_tmp199_ = cam16_color;
		he_color_from_params (_tmp198_.h, _tmp199_.c, 80.0, &_tmp200_);
		he_color_hct_blend (&_tmp197_, &_tmp200_, &_tmp201_);
		_tmp196_ = _tmp201_;
	} else {
		HeColorHCTColor _tmp202_ = {0};
		HeColorCAM16Color _tmp203_;
		HeColorCAM16Color _tmp204_;
		HeColorHCTColor _tmp205_ = {0};
		HeColorHCTColor _tmp206_ = {0};
		he_color_from_params (340.0, 60.0, 40.0, &_tmp202_);
		_tmp203_ = cam16_color;
		_tmp204_ = cam16_color;
		he_color_from_params (_tmp203_.h, _tmp204_.c, 40.0, &_tmp205_);
		he_color_hct_blend (&_tmp202_, &_tmp205_, &_tmp206_);
		_tmp196_ = _tmp206_;
	}
	fermion_pink_hct = _tmp196_;
	_tmp207_ = fermion_pink_hct;
	_tmp208_ = fermion_pink_hct;
	_tmp209_ = fermion_pink_hct;
	_tmp210_ = he_color_hct_to_hex (_tmp207_.h, _tmp208_.c, _tmp209_.t);
	fermion_pink_hex = _tmp210_;
	if (is_dark) {
		HeColorHCTColor _tmp212_ = {0};
		HeColorCAM16Color _tmp213_;
		HeColorCAM16Color _tmp214_;
		HeColorHCTColor _tmp215_ = {0};
		HeColorHCTColor _tmp216_ = {0};
		he_color_from_params (66.0, 12.0, 80.0, &_tmp212_);
		_tmp213_ = cam16_color;
		_tmp214_ = cam16_color;
		he_color_from_params (_tmp213_.h, _tmp214_.c, 80.0, &_tmp215_);
		he_color_hct_blend (&_tmp212_, &_tmp215_, &_tmp216_);
		_tmp211_ = _tmp216_;
	} else {
		HeColorHCTColor _tmp217_ = {0};
		HeColorCAM16Color _tmp218_;
		HeColorCAM16Color _tmp219_;
		HeColorHCTColor _tmp220_ = {0};
		HeColorHCTColor _tmp221_ = {0};
		he_color_from_params (61.0, 30.0, 40.0, &_tmp217_);
		_tmp218_ = cam16_color;
		_tmp219_ = cam16_color;
		he_color_from_params (_tmp218_.h, _tmp219_.c, 40.0, &_tmp220_);
		he_color_hct_blend (&_tmp217_, &_tmp220_, &_tmp221_);
		_tmp211_ = _tmp221_;
	}
	gluon_brown_hct = _tmp211_;
	_tmp222_ = gluon_brown_hct;
	_tmp223_ = gluon_brown_hct;
	_tmp224_ = gluon_brown_hct;
	_tmp225_ = he_color_hct_to_hex (_tmp222_.h, _tmp223_.c, _tmp224_.t);
	gluon_brown_hex = _tmp225_;
	_tmp226_ = g_strdup ("");
	css = _tmp226_;
	_tmp227_ = self->priv->desktop;
	_tmp228_ = he_desktop_get_prefers_color_scheme (_tmp227_);
	_tmp229_ = _tmp228_;
	if (_tmp229_ == HE_DESKTOP_COLOR_SCHEME_DARK) {
		HeScheme* _tmp230_;
		const gchar* _tmp231_;
		const gchar* _tmp232_;
		const gchar* _tmp233_;
		HeScheme* _tmp234_;
		const gchar* _tmp235_;
		const gchar* _tmp236_;
		const gchar* _tmp237_;
		HeScheme* _tmp238_;
		const gchar* _tmp239_;
		const gchar* _tmp240_;
		const gchar* _tmp241_;
		HeScheme* _tmp242_;
		const gchar* _tmp243_;
		const gchar* _tmp244_;
		const gchar* _tmp245_;
		HeScheme* _tmp246_;
		const gchar* _tmp247_;
		const gchar* _tmp248_;
		const gchar* _tmp249_;
		HeScheme* _tmp250_;
		const gchar* _tmp251_;
		const gchar* _tmp252_;
		const gchar* _tmp253_;
		HeScheme* _tmp254_;
		const gchar* _tmp255_;
		const gchar* _tmp256_;
		const gchar* _tmp257_;
		const gchar* _tmp258_;
		const gchar* _tmp259_;
		HeScheme* _tmp260_;
		const gchar* _tmp261_;
		const gchar* _tmp262_;
		const gchar* _tmp263_;
		const gchar* _tmp264_;
		const gchar* _tmp265_;
		HeScheme* _tmp266_;
		const gchar* _tmp267_;
		const gchar* _tmp268_;
		const gchar* _tmp269_;
		const gchar* _tmp270_;
		const gchar* _tmp271_;
		HeScheme* _tmp272_;
		const gchar* _tmp273_;
		const gchar* _tmp274_;
		const gchar* _tmp275_;
		const gchar* _tmp276_;
		const gchar* _tmp277_;
		HeScheme* _tmp278_;
		const gchar* _tmp279_;
		const gchar* _tmp280_;
		const gchar* _tmp281_;
		const gchar* _tmp282_;
		const gchar* _tmp283_;
		HeScheme* _tmp284_;
		const gchar* _tmp285_;
		const gchar* _tmp286_;
		const gchar* _tmp287_;
		HeScheme* _tmp288_;
		const gchar* _tmp289_;
		const gchar* _tmp290_;
		const gchar* _tmp291_;
		HeScheme* _tmp292_;
		const gchar* _tmp293_;
		const gchar* _tmp294_;
		const gchar* _tmp295_;
		HeScheme* _tmp296_;
		const gchar* _tmp297_;
		const gchar* _tmp298_;
		const gchar* _tmp299_;
		HeScheme* _tmp300_;
		const gchar* _tmp301_;
		const gchar* _tmp302_;
		const gchar* _tmp303_;
		const gchar* _tmp304_;
		const gchar* _tmp305_;
		const gchar* _tmp306_;
		const gchar* _tmp307_;
		const gchar* _tmp308_;
		const gchar* _tmp309_;
		const gchar* _tmp310_;
		const gchar* _tmp311_;
		const gchar* _tmp312_;
		const gchar* _tmp313_;
		const gchar* _tmp314_;
		const gchar* _tmp315_;
		HeScheme* _tmp316_;
		const gchar* _tmp317_;
		const gchar* _tmp318_;
		const gchar* _tmp319_;
		HeScheme* _tmp320_;
		const gchar* _tmp321_;
		const gchar* _tmp322_;
		const gchar* _tmp323_;
		HeScheme* _tmp324_;
		const gchar* _tmp325_;
		const gchar* _tmp326_;
		const gchar* _tmp327_;
		HeScheme* _tmp328_;
		const gchar* _tmp329_;
		const gchar* _tmp330_;
		const gchar* _tmp331_;
		HeScheme* _tmp332_;
		const gchar* _tmp333_;
		const gchar* _tmp334_;
		const gchar* _tmp335_;
		HeScheme* _tmp336_;
		const gchar* _tmp337_;
		const gchar* _tmp338_;
		const gchar* _tmp339_;
		const gchar* _tmp340_;
		const gchar* _tmp341_;
		const gchar* _tmp342_;
		const gchar* _tmp343_;
		const gchar* _tmp344_;
		const gchar* _tmp345_;
		const gchar* _tmp346_;
		const gchar* _tmp347_;
		const gchar* _tmp348_;
		const gchar* _tmp349_;
		const gchar* _tmp350_;
		const gchar* _tmp351_;
		HeScheme* _tmp352_;
		const gchar* _tmp353_;
		const gchar* _tmp354_;
		const gchar* _tmp355_;
		HeScheme* _tmp356_;
		const gchar* _tmp357_;
		const gchar* _tmp358_;
		const gchar* _tmp359_;
		HeScheme* _tmp360_;
		const gchar* _tmp361_;
		const gchar* _tmp362_;
		const gchar* _tmp363_;
		HeScheme* _tmp364_;
		const gchar* _tmp365_;
		const gchar* _tmp366_;
		const gchar* _tmp367_;
		HeScheme* _tmp368_;
		const gchar* _tmp369_;
		const gchar* _tmp370_;
		const gchar* _tmp371_;
		HeScheme* _tmp372_;
		const gchar* _tmp373_;
		const gchar* _tmp374_;
		const gchar* _tmp375_;
		HeScheme* _tmp376_;
		const gchar* _tmp377_;
		const gchar* _tmp378_;
		const gchar* _tmp379_;
		HeScheme* _tmp380_;
		const gchar* _tmp381_;
		const gchar* _tmp382_;
		const gchar* _tmp383_;
		HeScheme* _tmp384_;
		const gchar* _tmp385_;
		const gchar* _tmp386_;
		const gchar* _tmp387_;
		HeScheme* _tmp388_;
		const gchar* _tmp389_;
		const gchar* _tmp390_;
		const gchar* _tmp391_;
		gchar* _tmp392_;
		const gchar* _tmp393_;
		HeScheme* _tmp394_;
		const gchar* _tmp395_;
		const gchar* _tmp396_;
		const gchar* _tmp397_;
		HeScheme* _tmp398_;
		const gchar* _tmp399_;
		const gchar* _tmp400_;
		const gchar* _tmp401_;
		HeScheme* _tmp402_;
		const gchar* _tmp403_;
		const gchar* _tmp404_;
		const gchar* _tmp405_;
		gchar* _tmp406_;
		gchar* _tmp407_;
		gchar* _tmp408_;
		_tmp230_ = chosen_scheme;
		_tmp231_ = he_scheme_get_primary_hex (_tmp230_);
		_tmp232_ = _tmp231_;
		_tmp233_ = string_to_string (_tmp232_);
		_tmp234_ = chosen_scheme;
		_tmp235_ = he_scheme_get_primary_hex (_tmp234_);
		_tmp236_ = _tmp235_;
		_tmp237_ = string_to_string (_tmp236_);
		_tmp238_ = chosen_scheme;
		_tmp239_ = he_scheme_get_on_primary_hex (_tmp238_);
		_tmp240_ = _tmp239_;
		_tmp241_ = string_to_string (_tmp240_);
		_tmp242_ = chosen_scheme;
		_tmp243_ = he_scheme_get_primary_container_hex (_tmp242_);
		_tmp244_ = _tmp243_;
		_tmp245_ = string_to_string (_tmp244_);
		_tmp246_ = chosen_scheme;
		_tmp247_ = he_scheme_get_primary_container_hex (_tmp246_);
		_tmp248_ = _tmp247_;
		_tmp249_ = string_to_string (_tmp248_);
		_tmp250_ = chosen_scheme;
		_tmp251_ = he_scheme_get_on_primary_container_hex (_tmp250_);
		_tmp252_ = _tmp251_;
		_tmp253_ = string_to_string (_tmp252_);
		_tmp254_ = chosen_scheme;
		_tmp255_ = he_scheme_get_neutral_background_hex (_tmp254_);
		_tmp256_ = _tmp255_;
		_tmp257_ = string_to_string (_tmp256_);
		_tmp258_ = background_hex;
		_tmp259_ = string_to_string (_tmp258_);
		_tmp260_ = chosen_scheme;
		_tmp261_ = he_scheme_get_neutral_background_hex (_tmp260_);
		_tmp262_ = _tmp261_;
		_tmp263_ = string_to_string (_tmp262_);
		_tmp264_ = background_hex;
		_tmp265_ = string_to_string (_tmp264_);
		_tmp266_ = chosen_scheme;
		_tmp267_ = he_scheme_get_neutral_background_variant_hex (_tmp266_);
		_tmp268_ = _tmp267_;
		_tmp269_ = string_to_string (_tmp268_);
		_tmp270_ = background_hex;
		_tmp271_ = string_to_string (_tmp270_);
		_tmp272_ = chosen_scheme;
		_tmp273_ = he_scheme_get_neutral_background_hex (_tmp272_);
		_tmp274_ = _tmp273_;
		_tmp275_ = string_to_string (_tmp274_);
		_tmp276_ = background_hex;
		_tmp277_ = string_to_string (_tmp276_);
		_tmp278_ = chosen_scheme;
		_tmp279_ = he_scheme_get_neutral_background_hex (_tmp278_);
		_tmp280_ = _tmp279_;
		_tmp281_ = string_to_string (_tmp280_);
		_tmp282_ = background_hex;
		_tmp283_ = string_to_string (_tmp282_);
		_tmp284_ = chosen_scheme;
		_tmp285_ = he_scheme_get_neutral_foreground_hex (_tmp284_);
		_tmp286_ = _tmp285_;
		_tmp287_ = string_to_string (_tmp286_);
		_tmp288_ = chosen_scheme;
		_tmp289_ = he_scheme_get_neutral_foreground_hex (_tmp288_);
		_tmp290_ = _tmp289_;
		_tmp291_ = string_to_string (_tmp290_);
		_tmp292_ = chosen_scheme;
		_tmp293_ = he_scheme_get_neutral_foreground_variant_hex (_tmp292_);
		_tmp294_ = _tmp293_;
		_tmp295_ = string_to_string (_tmp294_);
		_tmp296_ = chosen_scheme;
		_tmp297_ = he_scheme_get_neutral_foreground_hex (_tmp296_);
		_tmp298_ = _tmp297_;
		_tmp299_ = string_to_string (_tmp298_);
		_tmp300_ = chosen_scheme;
		_tmp301_ = he_scheme_get_neutral_foreground_hex (_tmp300_);
		_tmp302_ = _tmp301_;
		_tmp303_ = string_to_string (_tmp302_);
		_tmp304_ = error_hex;
		_tmp305_ = string_to_string (_tmp304_);
		_tmp306_ = on_error_hex;
		_tmp307_ = string_to_string (_tmp306_);
		_tmp308_ = error_hex;
		_tmp309_ = string_to_string (_tmp308_);
		_tmp310_ = on_error_container_hex;
		_tmp311_ = string_to_string (_tmp310_);
		_tmp312_ = error_container_hex;
		_tmp313_ = string_to_string (_tmp312_);
		_tmp314_ = on_error_container_hex;
		_tmp315_ = string_to_string (_tmp314_);
		_tmp316_ = chosen_scheme;
		_tmp317_ = he_scheme_get_secondary_hex (_tmp316_);
		_tmp318_ = _tmp317_;
		_tmp319_ = string_to_string (_tmp318_);
		_tmp320_ = chosen_scheme;
		_tmp321_ = he_scheme_get_on_secondary_hex (_tmp320_);
		_tmp322_ = _tmp321_;
		_tmp323_ = string_to_string (_tmp322_);
		_tmp324_ = chosen_scheme;
		_tmp325_ = he_scheme_get_secondary_hex (_tmp324_);
		_tmp326_ = _tmp325_;
		_tmp327_ = string_to_string (_tmp326_);
		_tmp328_ = chosen_scheme;
		_tmp329_ = he_scheme_get_secondary_container_hex (_tmp328_);
		_tmp330_ = _tmp329_;
		_tmp331_ = string_to_string (_tmp330_);
		_tmp332_ = chosen_scheme;
		_tmp333_ = he_scheme_get_secondary_container_hex (_tmp332_);
		_tmp334_ = _tmp333_;
		_tmp335_ = string_to_string (_tmp334_);
		_tmp336_ = chosen_scheme;
		_tmp337_ = he_scheme_get_on_secondary_container_hex (_tmp336_);
		_tmp338_ = _tmp337_;
		_tmp339_ = string_to_string (_tmp338_);
		_tmp340_ = error_hex;
		_tmp341_ = string_to_string (_tmp340_);
		_tmp342_ = on_error_hex;
		_tmp343_ = string_to_string (_tmp342_);
		_tmp344_ = error_hex;
		_tmp345_ = string_to_string (_tmp344_);
		_tmp346_ = on_error_container_hex;
		_tmp347_ = string_to_string (_tmp346_);
		_tmp348_ = error_container_hex;
		_tmp349_ = string_to_string (_tmp348_);
		_tmp350_ = error_container_hex;
		_tmp351_ = string_to_string (_tmp350_);
		_tmp352_ = chosen_scheme;
		_tmp353_ = he_scheme_get_tertiary_hex (_tmp352_);
		_tmp354_ = _tmp353_;
		_tmp355_ = string_to_string (_tmp354_);
		_tmp356_ = chosen_scheme;
		_tmp357_ = he_scheme_get_on_tertiary_hex (_tmp356_);
		_tmp358_ = _tmp357_;
		_tmp359_ = string_to_string (_tmp358_);
		_tmp360_ = chosen_scheme;
		_tmp361_ = he_scheme_get_tertiary_hex (_tmp360_);
		_tmp362_ = _tmp361_;
		_tmp363_ = string_to_string (_tmp362_);
		_tmp364_ = chosen_scheme;
		_tmp365_ = he_scheme_get_tertiary_container_hex (_tmp364_);
		_tmp366_ = _tmp365_;
		_tmp367_ = string_to_string (_tmp366_);
		_tmp368_ = chosen_scheme;
		_tmp369_ = he_scheme_get_tertiary_container_hex (_tmp368_);
		_tmp370_ = _tmp369_;
		_tmp371_ = string_to_string (_tmp370_);
		_tmp372_ = chosen_scheme;
		_tmp373_ = he_scheme_get_on_tertiary_container_hex (_tmp372_);
		_tmp374_ = _tmp373_;
		_tmp375_ = string_to_string (_tmp374_);
		_tmp376_ = chosen_scheme;
		_tmp377_ = he_scheme_get_outline_hex (_tmp376_);
		_tmp378_ = _tmp377_;
		_tmp379_ = string_to_string (_tmp378_);
		_tmp380_ = chosen_scheme;
		_tmp381_ = he_scheme_get_outline_variant_hex (_tmp380_);
		_tmp382_ = _tmp381_;
		_tmp383_ = string_to_string (_tmp382_);
		_tmp384_ = chosen_scheme;
		_tmp385_ = he_scheme_get_shadow_hex (_tmp384_);
		_tmp386_ = _tmp385_;
		_tmp387_ = string_to_string (_tmp386_);
		_tmp388_ = chosen_scheme;
		_tmp389_ = he_scheme_get_scrim_hex (_tmp388_);
		_tmp390_ = _tmp389_;
		_tmp391_ = string_to_string (_tmp390_);
		_tmp392_ = g_strconcat ("\n      @define-color accent_color ", _tmp233_, ";\n      @define-color accent_bg_color ", _tmp237_, ";\n      @define-color accent_fg_color ", _tmp241_, ";\n\n      @define-color accent_container_color ", _tmp245_, ";\n      @define-color accent_container_bg_color ", _tmp249_, ";\n      @define-color accent_container_fg_color ", _tmp253_, ";\n\n      @define-color window_bg_color mix(", _tmp257_, ", ", _tmp259_, ", 0.5);\n      @define-color view_bg_color mix(", _tmp263_, ", ", _tmp265_, ", 0.5);\n      @define-color headerbar_bg_color mix(", _tmp269_, ", ", _tmp271_, ", 0.5);\n      @define-color popover_bg_color mix(", _tmp275_, ", ", _tmp277_, ", 0.5);\n      @define-color card_bg_color mix(", _tmp281_, ", ", _tmp283_, ", 0.5);\n\n      @define-color window_fg_color ", _tmp287_, ";\n      @define-color view_fg_color ", _tmp291_, ";\n      @define-color headerbar_fg_color ", _tmp295_, ";\n      @define-color popover_fg_color ", _tmp299_, ";\n      @define-color card_fg_color ", _tmp303_, ";\n\n      @define-color destructive_bg_color ", _tmp305_, ";\n      @define-color destructive_fg_color ", _tmp307_, ";\n      @define-color destructive_color ", _tmp309_, ";\n\n      @define-color destructive_container_color ", _tmp311_, ";\n      @define-color destructive_container_bg_color ", _tmp313_, ";\n      @define-color destructive_container_fg_color ", _tmp315_, ";\n\n      @define-color suggested_bg_color ", _tmp319_, ";\n      @define-color suggested_fg_color ", _tmp323_, ";\n      @define-color suggested_color ", _tmp327_, ";\n\n      @define-color suggested_container_color ", _tmp331_, ";\n      @define-color suggested_container_bg_color ", _tmp335_, ";\n      @define-color suggested_container_fg_color ", _tmp339_, ";\n\n      @define-color error_bg_color ", _tmp341_, ";\n      @define-color error_fg_color ", _tmp343_, ";\n      @define-color error_color ", _tmp345_, ";\n\n      @define-color error_container_color ", _tmp347_, ";\n      @define-color error_container_bg_color ", _tmp349_, ";\n      @define-color error_container_fg_color ", _tmp351_, ";\n\n      @define-color success_bg_color ", _tmp355_, ";\n      @define-color success_fg_color ", _tmp359_, ";\n      @define-color success_color ", _tmp363_, ";\n\n      @define-color success_container_color ", _tmp367_, ";\n      @define-color success_container_bg_color ", _tmp371_, ";\n      @define-color success_container_fg_color ", _tmp375_, ";\n\n      @define-color outline ", _tmp379_, ";\n      @define-color borders ", _tmp383_, ";\n\n      @define-color shadow ", _tmp387_, ";\n      @define-color scrim ", _tmp391_, ";\n      ", NULL);
		_g_free0 (css);
		css = _tmp392_;
		_tmp393_ = css;
		_tmp394_ = chosen_scheme;
		_tmp395_ = he_scheme_get_inverse_neutral_background_hex (_tmp394_);
		_tmp396_ = _tmp395_;
		_tmp397_ = string_to_string (_tmp396_);
		_tmp398_ = chosen_scheme;
		_tmp399_ = he_scheme_get_inverse_neutral_foreground_hex (_tmp398_);
		_tmp400_ = _tmp399_;
		_tmp401_ = string_to_string (_tmp400_);
		_tmp402_ = chosen_scheme;
		_tmp403_ = he_scheme_get_inverse_primary_hex (_tmp402_);
		_tmp404_ = _tmp403_;
		_tmp405_ = string_to_string (_tmp404_);
		_tmp406_ = g_strconcat ("\n      @define-color osd_bg_color ", _tmp397_, ";\n      @define-color osd_fg_color ", _tmp401_, ";\n      @define-color osd_accent_color ", _tmp405_, ";\n      ", NULL);
		_tmp407_ = _tmp406_;
		_tmp408_ = g_strconcat (_tmp393_, _tmp407_, NULL);
		_g_free0 (css);
		css = _tmp408_;
		_g_free0 (_tmp407_);
	} else {
		HeScheme* _tmp409_;
		const gchar* _tmp410_;
		const gchar* _tmp411_;
		const gchar* _tmp412_;
		HeScheme* _tmp413_;
		const gchar* _tmp414_;
		const gchar* _tmp415_;
		const gchar* _tmp416_;
		HeScheme* _tmp417_;
		const gchar* _tmp418_;
		const gchar* _tmp419_;
		const gchar* _tmp420_;
		HeScheme* _tmp421_;
		const gchar* _tmp422_;
		const gchar* _tmp423_;
		const gchar* _tmp424_;
		HeScheme* _tmp425_;
		const gchar* _tmp426_;
		const gchar* _tmp427_;
		const gchar* _tmp428_;
		HeScheme* _tmp429_;
		const gchar* _tmp430_;
		const gchar* _tmp431_;
		const gchar* _tmp432_;
		HeScheme* _tmp433_;
		const gchar* _tmp434_;
		const gchar* _tmp435_;
		const gchar* _tmp436_;
		HeScheme* _tmp437_;
		const gchar* _tmp438_;
		const gchar* _tmp439_;
		const gchar* _tmp440_;
		HeScheme* _tmp441_;
		const gchar* _tmp442_;
		const gchar* _tmp443_;
		const gchar* _tmp444_;
		HeScheme* _tmp445_;
		const gchar* _tmp446_;
		const gchar* _tmp447_;
		const gchar* _tmp448_;
		HeScheme* _tmp449_;
		const gchar* _tmp450_;
		const gchar* _tmp451_;
		const gchar* _tmp452_;
		HeScheme* _tmp453_;
		const gchar* _tmp454_;
		const gchar* _tmp455_;
		const gchar* _tmp456_;
		HeScheme* _tmp457_;
		const gchar* _tmp458_;
		const gchar* _tmp459_;
		const gchar* _tmp460_;
		HeScheme* _tmp461_;
		const gchar* _tmp462_;
		const gchar* _tmp463_;
		const gchar* _tmp464_;
		HeScheme* _tmp465_;
		const gchar* _tmp466_;
		const gchar* _tmp467_;
		const gchar* _tmp468_;
		HeScheme* _tmp469_;
		const gchar* _tmp470_;
		const gchar* _tmp471_;
		const gchar* _tmp472_;
		const gchar* _tmp473_;
		const gchar* _tmp474_;
		const gchar* _tmp475_;
		const gchar* _tmp476_;
		const gchar* _tmp477_;
		const gchar* _tmp478_;
		const gchar* _tmp479_;
		const gchar* _tmp480_;
		const gchar* _tmp481_;
		const gchar* _tmp482_;
		const gchar* _tmp483_;
		const gchar* _tmp484_;
		HeScheme* _tmp485_;
		const gchar* _tmp486_;
		const gchar* _tmp487_;
		const gchar* _tmp488_;
		HeScheme* _tmp489_;
		const gchar* _tmp490_;
		const gchar* _tmp491_;
		const gchar* _tmp492_;
		HeScheme* _tmp493_;
		const gchar* _tmp494_;
		const gchar* _tmp495_;
		const gchar* _tmp496_;
		HeScheme* _tmp497_;
		const gchar* _tmp498_;
		const gchar* _tmp499_;
		const gchar* _tmp500_;
		HeScheme* _tmp501_;
		const gchar* _tmp502_;
		const gchar* _tmp503_;
		const gchar* _tmp504_;
		HeScheme* _tmp505_;
		const gchar* _tmp506_;
		const gchar* _tmp507_;
		const gchar* _tmp508_;
		const gchar* _tmp509_;
		const gchar* _tmp510_;
		const gchar* _tmp511_;
		const gchar* _tmp512_;
		const gchar* _tmp513_;
		const gchar* _tmp514_;
		const gchar* _tmp515_;
		const gchar* _tmp516_;
		const gchar* _tmp517_;
		const gchar* _tmp518_;
		const gchar* _tmp519_;
		const gchar* _tmp520_;
		HeScheme* _tmp521_;
		const gchar* _tmp522_;
		const gchar* _tmp523_;
		const gchar* _tmp524_;
		HeScheme* _tmp525_;
		const gchar* _tmp526_;
		const gchar* _tmp527_;
		const gchar* _tmp528_;
		HeScheme* _tmp529_;
		const gchar* _tmp530_;
		const gchar* _tmp531_;
		const gchar* _tmp532_;
		HeScheme* _tmp533_;
		const gchar* _tmp534_;
		const gchar* _tmp535_;
		const gchar* _tmp536_;
		HeScheme* _tmp537_;
		const gchar* _tmp538_;
		const gchar* _tmp539_;
		const gchar* _tmp540_;
		HeScheme* _tmp541_;
		const gchar* _tmp542_;
		const gchar* _tmp543_;
		const gchar* _tmp544_;
		HeScheme* _tmp545_;
		const gchar* _tmp546_;
		const gchar* _tmp547_;
		const gchar* _tmp548_;
		HeScheme* _tmp549_;
		const gchar* _tmp550_;
		const gchar* _tmp551_;
		const gchar* _tmp552_;
		HeScheme* _tmp553_;
		const gchar* _tmp554_;
		const gchar* _tmp555_;
		const gchar* _tmp556_;
		HeScheme* _tmp557_;
		const gchar* _tmp558_;
		const gchar* _tmp559_;
		const gchar* _tmp560_;
		gchar* _tmp561_;
		const gchar* _tmp562_;
		HeScheme* _tmp563_;
		const gchar* _tmp564_;
		const gchar* _tmp565_;
		const gchar* _tmp566_;
		HeScheme* _tmp567_;
		const gchar* _tmp568_;
		const gchar* _tmp569_;
		const gchar* _tmp570_;
		HeScheme* _tmp571_;
		const gchar* _tmp572_;
		const gchar* _tmp573_;
		const gchar* _tmp574_;
		gchar* _tmp575_;
		gchar* _tmp576_;
		gchar* _tmp577_;
		_tmp409_ = chosen_scheme;
		_tmp410_ = he_scheme_get_primary_hex (_tmp409_);
		_tmp411_ = _tmp410_;
		_tmp412_ = string_to_string (_tmp411_);
		_tmp413_ = chosen_scheme;
		_tmp414_ = he_scheme_get_primary_hex (_tmp413_);
		_tmp415_ = _tmp414_;
		_tmp416_ = string_to_string (_tmp415_);
		_tmp417_ = chosen_scheme;
		_tmp418_ = he_scheme_get_on_primary_hex (_tmp417_);
		_tmp419_ = _tmp418_;
		_tmp420_ = string_to_string (_tmp419_);
		_tmp421_ = chosen_scheme;
		_tmp422_ = he_scheme_get_primary_container_hex (_tmp421_);
		_tmp423_ = _tmp422_;
		_tmp424_ = string_to_string (_tmp423_);
		_tmp425_ = chosen_scheme;
		_tmp426_ = he_scheme_get_primary_container_hex (_tmp425_);
		_tmp427_ = _tmp426_;
		_tmp428_ = string_to_string (_tmp427_);
		_tmp429_ = chosen_scheme;
		_tmp430_ = he_scheme_get_on_primary_container_hex (_tmp429_);
		_tmp431_ = _tmp430_;
		_tmp432_ = string_to_string (_tmp431_);
		_tmp433_ = chosen_scheme;
		_tmp434_ = he_scheme_get_neutral_background_hex (_tmp433_);
		_tmp435_ = _tmp434_;
		_tmp436_ = string_to_string (_tmp435_);
		_tmp437_ = chosen_scheme;
		_tmp438_ = he_scheme_get_neutral_background_hex (_tmp437_);
		_tmp439_ = _tmp438_;
		_tmp440_ = string_to_string (_tmp439_);
		_tmp441_ = chosen_scheme;
		_tmp442_ = he_scheme_get_neutral_background_variant_hex (_tmp441_);
		_tmp443_ = _tmp442_;
		_tmp444_ = string_to_string (_tmp443_);
		_tmp445_ = chosen_scheme;
		_tmp446_ = he_scheme_get_neutral_background_hex (_tmp445_);
		_tmp447_ = _tmp446_;
		_tmp448_ = string_to_string (_tmp447_);
		_tmp449_ = chosen_scheme;
		_tmp450_ = he_scheme_get_neutral_background_hex (_tmp449_);
		_tmp451_ = _tmp450_;
		_tmp452_ = string_to_string (_tmp451_);
		_tmp453_ = chosen_scheme;
		_tmp454_ = he_scheme_get_neutral_foreground_hex (_tmp453_);
		_tmp455_ = _tmp454_;
		_tmp456_ = string_to_string (_tmp455_);
		_tmp457_ = chosen_scheme;
		_tmp458_ = he_scheme_get_neutral_foreground_hex (_tmp457_);
		_tmp459_ = _tmp458_;
		_tmp460_ = string_to_string (_tmp459_);
		_tmp461_ = chosen_scheme;
		_tmp462_ = he_scheme_get_neutral_foreground_variant_hex (_tmp461_);
		_tmp463_ = _tmp462_;
		_tmp464_ = string_to_string (_tmp463_);
		_tmp465_ = chosen_scheme;
		_tmp466_ = he_scheme_get_neutral_foreground_hex (_tmp465_);
		_tmp467_ = _tmp466_;
		_tmp468_ = string_to_string (_tmp467_);
		_tmp469_ = chosen_scheme;
		_tmp470_ = he_scheme_get_neutral_foreground_hex (_tmp469_);
		_tmp471_ = _tmp470_;
		_tmp472_ = string_to_string (_tmp471_);
		_tmp473_ = error_hex;
		_tmp474_ = string_to_string (_tmp473_);
		_tmp475_ = on_error_hex;
		_tmp476_ = string_to_string (_tmp475_);
		_tmp477_ = error_hex;
		_tmp478_ = string_to_string (_tmp477_);
		_tmp479_ = on_error_container_hex;
		_tmp480_ = string_to_string (_tmp479_);
		_tmp481_ = error_container_hex;
		_tmp482_ = string_to_string (_tmp481_);
		_tmp483_ = on_error_container_hex;
		_tmp484_ = string_to_string (_tmp483_);
		_tmp485_ = chosen_scheme;
		_tmp486_ = he_scheme_get_secondary_hex (_tmp485_);
		_tmp487_ = _tmp486_;
		_tmp488_ = string_to_string (_tmp487_);
		_tmp489_ = chosen_scheme;
		_tmp490_ = he_scheme_get_on_secondary_hex (_tmp489_);
		_tmp491_ = _tmp490_;
		_tmp492_ = string_to_string (_tmp491_);
		_tmp493_ = chosen_scheme;
		_tmp494_ = he_scheme_get_secondary_hex (_tmp493_);
		_tmp495_ = _tmp494_;
		_tmp496_ = string_to_string (_tmp495_);
		_tmp497_ = chosen_scheme;
		_tmp498_ = he_scheme_get_secondary_container_hex (_tmp497_);
		_tmp499_ = _tmp498_;
		_tmp500_ = string_to_string (_tmp499_);
		_tmp501_ = chosen_scheme;
		_tmp502_ = he_scheme_get_secondary_container_hex (_tmp501_);
		_tmp503_ = _tmp502_;
		_tmp504_ = string_to_string (_tmp503_);
		_tmp505_ = chosen_scheme;
		_tmp506_ = he_scheme_get_on_secondary_container_hex (_tmp505_);
		_tmp507_ = _tmp506_;
		_tmp508_ = string_to_string (_tmp507_);
		_tmp509_ = error_hex;
		_tmp510_ = string_to_string (_tmp509_);
		_tmp511_ = on_error_hex;
		_tmp512_ = string_to_string (_tmp511_);
		_tmp513_ = error_hex;
		_tmp514_ = string_to_string (_tmp513_);
		_tmp515_ = on_error_container_hex;
		_tmp516_ = string_to_string (_tmp515_);
		_tmp517_ = error_container_hex;
		_tmp518_ = string_to_string (_tmp517_);
		_tmp519_ = error_container_hex;
		_tmp520_ = string_to_string (_tmp519_);
		_tmp521_ = chosen_scheme;
		_tmp522_ = he_scheme_get_tertiary_hex (_tmp521_);
		_tmp523_ = _tmp522_;
		_tmp524_ = string_to_string (_tmp523_);
		_tmp525_ = chosen_scheme;
		_tmp526_ = he_scheme_get_on_tertiary_hex (_tmp525_);
		_tmp527_ = _tmp526_;
		_tmp528_ = string_to_string (_tmp527_);
		_tmp529_ = chosen_scheme;
		_tmp530_ = he_scheme_get_tertiary_hex (_tmp529_);
		_tmp531_ = _tmp530_;
		_tmp532_ = string_to_string (_tmp531_);
		_tmp533_ = chosen_scheme;
		_tmp534_ = he_scheme_get_tertiary_container_hex (_tmp533_);
		_tmp535_ = _tmp534_;
		_tmp536_ = string_to_string (_tmp535_);
		_tmp537_ = chosen_scheme;
		_tmp538_ = he_scheme_get_tertiary_container_hex (_tmp537_);
		_tmp539_ = _tmp538_;
		_tmp540_ = string_to_string (_tmp539_);
		_tmp541_ = chosen_scheme;
		_tmp542_ = he_scheme_get_on_tertiary_container_hex (_tmp541_);
		_tmp543_ = _tmp542_;
		_tmp544_ = string_to_string (_tmp543_);
		_tmp545_ = chosen_scheme;
		_tmp546_ = he_scheme_get_outline_hex (_tmp545_);
		_tmp547_ = _tmp546_;
		_tmp548_ = string_to_string (_tmp547_);
		_tmp549_ = chosen_scheme;
		_tmp550_ = he_scheme_get_outline_variant_hex (_tmp549_);
		_tmp551_ = _tmp550_;
		_tmp552_ = string_to_string (_tmp551_);
		_tmp553_ = chosen_scheme;
		_tmp554_ = he_scheme_get_shadow_hex (_tmp553_);
		_tmp555_ = _tmp554_;
		_tmp556_ = string_to_string (_tmp555_);
		_tmp557_ = chosen_scheme;
		_tmp558_ = he_scheme_get_scrim_hex (_tmp557_);
		_tmp559_ = _tmp558_;
		_tmp560_ = string_to_string (_tmp559_);
		_tmp561_ = g_strconcat ("\n      @define-color accent_color ", _tmp412_, ";\n      @define-color accent_bg_color ", _tmp416_, ";\n      @define-color accent_fg_color ", _tmp420_, ";\n\n      @define-color accent_container_color ", _tmp424_, ";\n      @define-color accent_container_bg_color ", _tmp428_, ";\n      @define-color accent_container_fg_color ", _tmp432_, ";\n\n      @define-color window_bg_color ", _tmp436_, ";\n      @define-color view_bg_color ", _tmp440_, ";\n      @define-color headerbar_bg_color ", _tmp444_, ";\n      @define-color popover_bg_color ", _tmp448_, ";\n      @define-color card_bg_color ", _tmp452_, ";\n\n      @define-color window_fg_color ", _tmp456_, ";\n      @define-color view_fg_color ", _tmp460_, ";\n      @define-color headerbar_fg_color ", _tmp464_, ";\n      @define-color popover_fg_color ", _tmp468_, ";\n      @define-color card_fg_color ", _tmp472_, ";\n\n      @define-color destructive_bg_color ", _tmp474_, ";\n      @define-color destructive_fg_color ", _tmp476_, ";\n      @define-color destructive_color ", _tmp478_, ";\n\n      @define-color destructive_container_color ", _tmp480_, ";\n      @define-color destructive_container_bg_color ", _tmp482_, ";\n      @define-color destructive_container_fg_color ", _tmp484_, ";\n\n      @define-color suggested_bg_color ", _tmp488_, ";\n      @define-color suggested_fg_color ", _tmp492_, ";\n      @define-color suggested_color ", _tmp496_, ";\n\n      @define-color suggested_container_color ", _tmp500_, ";\n      @define-color suggested_container_bg_color ", _tmp504_, ";\n      @define-color suggested_container_fg_color ", _tmp508_, ";\n\n      @define-color error_bg_color ", _tmp510_, ";\n      @define-color error_fg_color ", _tmp512_, ";\n      @define-color error_color ", _tmp514_, ";\n\n      @define-color error_container_color ", _tmp516_, ";\n      @define-color error_container_bg_color ", _tmp518_, ";\n      @define-color error_container_fg_color ", _tmp520_, ";\n\n      @define-color success_bg_color ", _tmp524_, ";\n      @define-color success_fg_color ", _tmp528_, ";\n      @define-color success_color ", _tmp532_, ";\n\n      @define-color success_container_color ", _tmp536_, ";\n      @define-color success_container_bg_color ", _tmp540_, ";\n      @define-color success_container_fg_color ", _tmp544_, ";\n\n      @define-color outline ", _tmp548_, ";\n      @define-color borders ", _tmp552_, ";\n\n      @define-color shadow ", _tmp556_, ";\n      @define-color scrim ", _tmp560_, ";\n      ", NULL);
		_g_free0 (css);
		css = _tmp561_;
		_tmp562_ = css;
		_tmp563_ = chosen_scheme;
		_tmp564_ = he_scheme_get_inverse_neutral_background_hex (_tmp563_);
		_tmp565_ = _tmp564_;
		_tmp566_ = string_to_string (_tmp565_);
		_tmp567_ = chosen_scheme;
		_tmp568_ = he_scheme_get_inverse_neutral_foreground_hex (_tmp567_);
		_tmp569_ = _tmp568_;
		_tmp570_ = string_to_string (_tmp569_);
		_tmp571_ = chosen_scheme;
		_tmp572_ = he_scheme_get_inverse_primary_hex (_tmp571_);
		_tmp573_ = _tmp572_;
		_tmp574_ = string_to_string (_tmp573_);
		_tmp575_ = g_strconcat ("\n      @define-color osd_bg_color ", _tmp566_, ";\n      @define-color osd_fg_color ", _tmp570_, ";\n      @define-color osd_accent_color ", _tmp574_, ";\n      ", NULL);
		_tmp576_ = _tmp575_;
		_tmp577_ = g_strconcat (_tmp562_, _tmp576_, NULL);
		_g_free0 (css);
		css = _tmp577_;
		_g_free0 (_tmp576_);
	}
	_tmp578_ = css;
	_tmp579_ = meson_red_hex;
	_tmp580_ = string_to_string (_tmp579_);
	_tmp581_ = lepton_orange_hex;
	_tmp582_ = string_to_string (_tmp581_);
	_tmp583_ = electron_yellow_hex;
	_tmp584_ = string_to_string (_tmp583_);
	_tmp585_ = muon_green_hex;
	_tmp586_ = string_to_string (_tmp585_);
	_tmp587_ = baryon_mint_hex;
	_tmp588_ = string_to_string (_tmp587_);
	_tmp589_ = proton_blue_hex;
	_tmp590_ = string_to_string (_tmp589_);
	_tmp591_ = photon_indigo_hex;
	_tmp592_ = string_to_string (_tmp591_);
	_tmp593_ = tau_purple_hex;
	_tmp594_ = string_to_string (_tmp593_);
	_tmp595_ = fermion_pink_hex;
	_tmp596_ = string_to_string (_tmp595_);
	_tmp597_ = gluon_brown_hex;
	_tmp598_ = string_to_string (_tmp597_);
	_tmp599_ = g_strconcat ("\n      @define-color meson_red ", _tmp580_, ";\n      @define-color lepton_orange ", _tmp582_, ";\n      @define-color electron_yellow ", _tmp584_, ";\n      @define-color muon_green ", _tmp586_, ";\n      @define-color baryon_mint ", _tmp588_, ";\n      @define-color proton_blue ", _tmp590_, ";\n      @define-color photon_indigo ", _tmp592_, ";\n      @define-color tau_purple ", _tmp594_, ";\n      @define-color fermion_pink ", _tmp596_, ";\n      @define-color gluon_brown ", _tmp598_, ";\n    ", NULL);
	_tmp600_ = _tmp599_;
	_tmp601_ = g_strconcat (_tmp578_, _tmp600_, NULL);
	_g_free0 (css);
	css = _tmp601_;
	_g_free0 (_tmp600_);
	_tmp602_ = self->priv->desktop;
	_tmp603_ = he_desktop_get_font_weight (_tmp602_);
	_tmp604_ = _tmp603_;
	if (_tmp604_ == 0.0) {
		gdouble light_weight = 0.0;
		gdouble heavy_weight = 0.0;
		const gchar* _tmp605_;
		gchar* _tmp606_;
		gchar* _tmp607_;
		gchar* _tmp608_;
		gchar* _tmp609_;
		gchar* _tmp610_;
		gchar* _tmp611_;
		gchar* _tmp612_;
		gchar* _tmp613_;
		gchar* _tmp614_;
		gchar* _tmp615_;
		gchar* _tmp616_;
		gchar* _tmp617_;
		gchar* _tmp618_;
		gchar* _tmp619_;
		gchar* _tmp620_;
		gchar* _tmp621_;
		gchar* _tmp622_;
		gchar* _tmp623_;
		gchar* _tmp624_;
		gchar* _tmp625_;
		gchar* _tmp626_;
		gchar* _tmp627_;
		gchar* _tmp628_;
		gchar* _tmp629_;
		gchar* _tmp630_;
		gchar* _tmp631_;
		gchar* _tmp632_;
		gchar* _tmp633_;
		gchar* _tmp634_;
		gchar* _tmp635_;
		gchar* _tmp636_;
		gchar* _tmp637_;
		gchar* _tmp638_;
		gchar* _tmp639_;
		gchar* _tmp640_;
		gchar* _tmp641_;
		gchar* _tmp642_;
		gchar* _tmp643_;
		gchar* _tmp644_;
		gchar* _tmp645_;
		gchar* _tmp646_;
		light_weight = (gdouble) 300;
		heavy_weight = (gdouble) 700;
		_tmp605_ = css;
		_tmp606_ = double_to_string (weight);
		_tmp607_ = _tmp606_;
		_tmp608_ = double_to_string (heavy_weight);
		_tmp609_ = _tmp608_;
		_tmp610_ = double_to_string (weight);
		_tmp611_ = _tmp610_;
		_tmp612_ = double_to_string (weight);
		_tmp613_ = _tmp612_;
		_tmp614_ = double_to_string (light_weight);
		_tmp615_ = _tmp614_;
		_tmp616_ = double_to_string (light_weight);
		_tmp617_ = _tmp616_;
		_tmp618_ = double_to_string (weight);
		_tmp619_ = _tmp618_;
		_tmp620_ = double_to_string (heavy_weight);
		_tmp621_ = _tmp620_;
		_tmp622_ = double_to_string (weight);
		_tmp623_ = _tmp622_;
		_tmp624_ = double_to_string (heavy_weight);
		_tmp625_ = _tmp624_;
		_tmp626_ = double_to_string (weight);
		_tmp627_ = _tmp626_;
		_tmp628_ = double_to_string (heavy_weight);
		_tmp629_ = _tmp628_;
		_tmp630_ = double_to_string (light_weight);
		_tmp631_ = _tmp630_;
		_tmp632_ = double_to_string (heavy_weight);
		_tmp633_ = _tmp632_;
		_tmp634_ = double_to_string (heavy_weight);
		_tmp635_ = _tmp634_;
		_tmp636_ = double_to_string (heavy_weight);
		_tmp637_ = _tmp636_;
		_tmp638_ = double_to_string (heavy_weight);
		_tmp639_ = _tmp638_;
		_tmp640_ = double_to_string (heavy_weight);
		_tmp641_ = _tmp640_;
		_tmp642_ = double_to_string (heavy_weight);
		_tmp643_ = _tmp642_;
		_tmp644_ = g_strconcat ("\n      label {\n        font-weight: ", _tmp607_, ";\n      }\n      button label {\n        font-weight: ", _tmp609_, ";\n" \
"      }\n" \
"      .view-switcher button label {\n" \
"        font-weight: ", _tmp611_, ";\n      }\n      .big-display {\n        font-weight: ", _tmp613_, ";\n      }\n      .display {\n        font-weight: ", _tmp615_, ";\n      }\n      .view-title {\n        font-weight: ", _tmp617_, ";\n      }\n      .view-subtitle {\n        font-weight: ", _tmp619_, ";\n      }\n      .cb-title {\n        font-weight: ", _tmp621_, ";\n      }\n      .cb-subtitle {\n        font-weight: ", _tmp623_, ";\n      }\n      .header {\n        font-weight: ", _tmp625_, ";\n      }\n      .body {\n        font-weight: ", _tmp627_, ";\n      }\n      .caption {\n        font-weight: ", _tmp629_, ";\n      }\n      .large-title {\n        font-weight: ", _tmp631_, ";\n      }\n      .title-1 {\n        font-weight: ", _tmp633_, ";\n      }\n      .title-2 {\n        font-weight: ", _tmp635_, ";\n      }\n      .title-3 {\n        font-weight: ", _tmp637_, ";\n      }\n      .title-4 {\n        font-weight: ", _tmp639_, ";\n      }\n      .heading {\n        font-weight: ", _tmp641_, ";\n      }\n      .caption-heading {\n        font-weight: ", _tmp643_, ";\n      }\n      ", NULL);
		_tmp645_ = _tmp644_;
		_tmp646_ = g_strconcat (_tmp605_, _tmp645_, NULL);
		_g_free0 (css);
		css = _tmp646_;
		_g_free0 (_tmp645_);
		_g_free0 (_tmp643_);
		_g_free0 (_tmp641_);
		_g_free0 (_tmp639_);
		_g_free0 (_tmp637_);
		_g_free0 (_tmp635_);
		_g_free0 (_tmp633_);
		_g_free0 (_tmp631_);
		_g_free0 (_tmp629_);
		_g_free0 (_tmp627_);
		_g_free0 (_tmp625_);
		_g_free0 (_tmp623_);
		_g_free0 (_tmp621_);
		_g_free0 (_tmp619_);
		_g_free0 (_tmp617_);
		_g_free0 (_tmp615_);
		_g_free0 (_tmp613_);
		_g_free0 (_tmp611_);
		_g_free0 (_tmp609_);
		_g_free0 (_tmp607_);
	} else {
		gdouble light_weight = 0.0;
		HeDesktop* _tmp647_;
		gdouble _tmp648_;
		gdouble _tmp649_;
		gdouble heavy_weight = 0.0;
		HeDesktop* _tmp650_;
		gdouble _tmp651_;
		gdouble _tmp652_;
		const gchar* _tmp653_;
		gchar* _tmp654_;
		gchar* _tmp655_;
		gchar* _tmp656_;
		gchar* _tmp657_;
		gchar* _tmp658_;
		gchar* _tmp659_;
		gchar* _tmp660_;
		gchar* _tmp661_;
		gchar* _tmp662_;
		gchar* _tmp663_;
		gchar* _tmp664_;
		gchar* _tmp665_;
		gchar* _tmp666_;
		gchar* _tmp667_;
		gchar* _tmp668_;
		gchar* _tmp669_;
		gchar* _tmp670_;
		gchar* _tmp671_;
		gchar* _tmp672_;
		gchar* _tmp673_;
		gchar* _tmp674_;
		gchar* _tmp675_;
		gchar* _tmp676_;
		gchar* _tmp677_;
		gchar* _tmp678_;
		gchar* _tmp679_;
		gchar* _tmp680_;
		gchar* _tmp681_;
		gchar* _tmp682_;
		gchar* _tmp683_;
		gchar* _tmp684_;
		gchar* _tmp685_;
		gchar* _tmp686_;
		gchar* _tmp687_;
		gchar* _tmp688_;
		gchar* _tmp689_;
		gchar* _tmp690_;
		gchar* _tmp691_;
		gchar* _tmp692_;
		gchar* _tmp693_;
		gchar* _tmp694_;
		_tmp647_ = self->priv->desktop;
		_tmp648_ = he_desktop_get_font_weight (_tmp647_);
		_tmp649_ = _tmp648_;
		light_weight = 300 * _tmp649_;
		_tmp650_ = self->priv->desktop;
		_tmp651_ = he_desktop_get_font_weight (_tmp650_);
		_tmp652_ = _tmp651_;
		heavy_weight = 700 * _tmp652_;
		_tmp653_ = css;
		_tmp654_ = double_to_string (weight);
		_tmp655_ = _tmp654_;
		_tmp656_ = double_to_string (heavy_weight);
		_tmp657_ = _tmp656_;
		_tmp658_ = double_to_string (weight);
		_tmp659_ = _tmp658_;
		_tmp660_ = double_to_string (weight);
		_tmp661_ = _tmp660_;
		_tmp662_ = double_to_string (light_weight);
		_tmp663_ = _tmp662_;
		_tmp664_ = double_to_string (light_weight);
		_tmp665_ = _tmp664_;
		_tmp666_ = double_to_string (weight);
		_tmp667_ = _tmp666_;
		_tmp668_ = double_to_string (heavy_weight);
		_tmp669_ = _tmp668_;
		_tmp670_ = double_to_string (weight);
		_tmp671_ = _tmp670_;
		_tmp672_ = double_to_string (heavy_weight);
		_tmp673_ = _tmp672_;
		_tmp674_ = double_to_string (weight);
		_tmp675_ = _tmp674_;
		_tmp676_ = double_to_string (heavy_weight);
		_tmp677_ = _tmp676_;
		_tmp678_ = double_to_string (light_weight);
		_tmp679_ = _tmp678_;
		_tmp680_ = double_to_string (heavy_weight);
		_tmp681_ = _tmp680_;
		_tmp682_ = double_to_string (heavy_weight);
		_tmp683_ = _tmp682_;
		_tmp684_ = double_to_string (heavy_weight);
		_tmp685_ = _tmp684_;
		_tmp686_ = double_to_string (heavy_weight);
		_tmp687_ = _tmp686_;
		_tmp688_ = double_to_string (heavy_weight);
		_tmp689_ = _tmp688_;
		_tmp690_ = double_to_string (heavy_weight);
		_tmp691_ = _tmp690_;
		_tmp692_ = g_strconcat ("\n      label {\n        font-weight: ", _tmp655_, ";\n      }\n      button label {\n        font-weight: ", _tmp657_, ";\n" \
"      }\n" \
"      .view-switcher button label {\n" \
"        font-weight: ", _tmp659_, ";\n      }\n      .big-display {\n        font-weight: ", _tmp661_, ";\n      }\n      .display {\n        font-weight: ", _tmp663_, ";\n      }\n      .view-title {\n        font-weight: ", _tmp665_, ";\n      }\n      .view-subtitle {\n        font-weight: ", _tmp667_, ";\n      }\n      .cb-title {\n        font-weight: ", _tmp669_, ";\n      }\n      .cb-subtitle {\n        font-weight: ", _tmp671_, ";\n      }\n      .header {\n        font-weight: ", _tmp673_, ";\n      }\n      .body {\n        font-weight: ", _tmp675_, ";\n      }\n      .caption {\n        font-weight: ", _tmp677_, ";\n      }\n      .large-title {\n        font-weight: ", _tmp679_, ";\n      }\n      .title-1 {\n        font-weight: ", _tmp681_, ";\n      }\n      .title-2 {\n        font-weight: ", _tmp683_, ";\n      }\n      .title-3 {\n        font-weight: ", _tmp685_, ";\n      }\n      .title-4 {\n        font-weight: ", _tmp687_, ";\n      }\n      .heading {\n        font-weight: ", _tmp689_, ";\n      }\n      .caption-heading {\n        font-weight: ", _tmp691_, ";\n      }\n      ", NULL);
		_tmp693_ = _tmp692_;
		_tmp694_ = g_strconcat (_tmp653_, _tmp693_, NULL);
		_g_free0 (css);
		css = _tmp694_;
		_g_free0 (_tmp693_);
		_g_free0 (_tmp691_);
		_g_free0 (_tmp689_);
		_g_free0 (_tmp687_);
		_g_free0 (_tmp685_);
		_g_free0 (_tmp683_);
		_g_free0 (_tmp681_);
		_g_free0 (_tmp679_);
		_g_free0 (_tmp677_);
		_g_free0 (_tmp675_);
		_g_free0 (_tmp673_);
		_g_free0 (_tmp671_);
		_g_free0 (_tmp669_);
		_g_free0 (_tmp667_);
		_g_free0 (_tmp665_);
		_g_free0 (_tmp663_);
		_g_free0 (_tmp661_);
		_g_free0 (_tmp659_);
		_g_free0 (_tmp657_);
		_g_free0 (_tmp655_);
	}
	_tmp695_ = self->priv->accent;
	_tmp696_ = css;
	_tmp697_ = string_get_data (_tmp696_, &_tmp698_);
	_tmp697__length1 = _tmp698_;
	_tmp699_ = _tmp697_;
	_tmp699__length1 = _tmp697__length1;
	gtk_css_provider_load_from_data (_tmp695_, _tmp699_, (gssize) _tmp699__length1);
	_tmp700_ = self->priv->light;
	he_application_style_provider_set_enabled (self, _tmp700_, !is_dark, HE_APPLICATION_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp701_ = self->priv->dark;
	he_application_style_provider_set_enabled (self, _tmp701_, is_dark, HE_APPLICATION_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp702_ = self->priv->user_dark;
	he_application_style_provider_set_enabled (self, _tmp702_, is_dark, HE_APPLICATION_STYLE_PROVIDER_PRIORITY_USER_DARK);
	_g_free0 (css);
	_g_free0 (gluon_brown_hex);
	_g_free0 (fermion_pink_hex);
	_g_free0 (tau_purple_hex);
	_g_free0 (photon_indigo_hex);
	_g_free0 (proton_blue_hex);
	_g_free0 (baryon_mint_hex);
	_g_free0 (muon_green_hex);
	_g_free0 (electron_yellow_hex);
	_g_free0 (lepton_orange_hex);
	_g_free0 (meson_red_hex);
	_g_free0 (on_error_container_hex);
	_g_free0 (error_container_hex);
	_g_free0 (on_error_hex);
	_g_free0 (error_hex);
	_g_object_unref0 (chosen_scheme);
	_g_free0 (background_hex);
}

static void
_he_application_update_style_providers_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
	he_application_update_style_providers ((HeApplication*) self);
}

static void
he_application_init_style_providers (HeApplication* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	HeDesktop* _tmp4_;
	HeDesktop* _tmp5_;
	HeDesktop* _tmp6_;
	HeDesktop* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->light;
	gtk_css_provider_load_from_resource (_tmp0_, "/com/fyralabs/helium/gtk.css");
	_tmp1_ = self->priv->dark;
	gtk_css_provider_load_from_resource (_tmp1_, "/com/fyralabs/helium/gtk-dark.css");
	_tmp2_ = self->priv->accent;
	he_application_style_provider_set_enabled (self, _tmp2_, TRUE, HE_APPLICATION_STYLE_PROVIDER_PRIORITY_ACCENT);
	_tmp3_ = self->priv->user_base;
	he_application_style_provider_set_enabled (self, _tmp3_, TRUE, HE_APPLICATION_STYLE_PROVIDER_PRIORITY_USER_BASE);
	he_application_update_style_providers (self);
	_tmp4_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::prefers-color-scheme", (GCallback) _he_application_update_style_providers_g_object_notify, self, 0);
	_tmp5_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::dark-mode-strength", (GCallback) _he_application_update_style_providers_g_object_notify, self, 0);
	_tmp6_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp6_, "notify::ensor-scheme", (GCallback) _he_application_update_style_providers_g_object_notify, self, 0);
	_tmp7_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::font-weight", (GCallback) _he_application_update_style_providers_g_object_notify, self, 0);
}

static void
he_application_init_app_providers (HeApplication* self)
{
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GtkCssProvider* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GtkCssProvider* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) self);
	_tmp1_ = g_strdup (_tmp0_);
	base_path = _tmp1_;
	_tmp2_ = base_path;
	if (_tmp2_ == NULL) {
		_g_free0 (base_path);
		return;
	}
	_tmp3_ = base_path;
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
	base_uri = _tmp4_;
	_tmp5_ = base_uri;
	_tmp6_ = g_file_new_for_uri (_tmp5_);
	base_file = _tmp6_;
	_tmp7_ = self->priv->user_base;
	_tmp8_ = base_file;
	_tmp9_ = g_file_get_child (_tmp8_, "style.css");
	_tmp10_ = _tmp9_;
	he_application_init_provider_from_file (self, _tmp7_, _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = self->priv->user_dark;
	_tmp12_ = base_file;
	_tmp13_ = g_file_get_child (_tmp12_, "style-dark.css");
	_tmp14_ = _tmp13_;
	he_application_init_provider_from_file (self, _tmp11_, _tmp14_);
	_g_object_unref0 (_tmp14_);
	_g_object_unref0 (base_file);
	_g_free0 (base_uri);
	_g_free0 (base_path);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
he_application_style_provider_set_enabled (HeApplication* self,
                                           GtkCssProvider* provider,
                                           gboolean enabled,
                                           gint priority)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (provider != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = display;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (display);
		return;
	}
	if (enabled) {
		GdkDisplay* _tmp3_;
		_tmp3_ = display;
		gtk_style_context_add_provider_for_display (_tmp3_, (GtkStyleProvider*) provider, (guint) priority);
	} else {
		GdkDisplay* _tmp4_;
		_tmp4_ = display;
		gtk_style_context_remove_provider_for_display (_tmp4_, (GtkStyleProvider*) provider);
	}
	_g_object_unref0 (display);
}

static void
he_application_init_provider_from_file (HeApplication* self,
                                        GtkCssProvider* provider,
                                        GFile* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (provider != NULL);
	g_return_if_fail (file != NULL);
	if (g_file_query_exists (file, NULL)) {
		gtk_css_provider_load_from_file (provider, file);
	}
}

static void
he_application_real_startup (GApplication* base)
{
	HeApplication * self;
	self = (HeApplication*) base;
	G_APPLICATION_CLASS (he_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
	he_init ();
	he_application_init_app_providers (self);
	he_application_init_style_providers (self);
}

/**
   * Creates a new application.
   *
   * @param application_id The application ID in reverse domain name notation
   * @param flags The application flags, as defined in GIO.ApplicationFlags
   */
HeApplication*
he_application_construct (GType object_type,
                          const gchar* application_id,
                          GApplicationFlags flags)
{
	HeApplication * self = NULL;
	self = (HeApplication*) g_object_new (object_type, NULL);
	g_application_set_application_id ((GApplication*) self, application_id);
	g_application_set_flags ((GApplication*) self, flags);
	return self;
}

HeApplication*
he_application_new (const gchar* application_id,
                    GApplicationFlags flags)
{
	return he_application_construct (HE_TYPE_APPLICATION, application_id, flags);
}

static void
he_application_class_init (HeApplicationClass * klass,
                           gpointer klass_data)
{
	he_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeApplication_private_offset);
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) he_application_real_startup;
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_set_property;
	G_OBJECT_CLASS (klass)->finalize = he_application_finalize;
	/**
	  * A default accent color if the user has not set one.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("default-accent-color", "default-accent-color", "default-accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY] = g_param_spec_double ("default-font-weight", "default-font-weight", "default-font-weight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_FOREGROUND_PROPERTY, he_application_properties[HE_APPLICATION_FOREGROUND_PROPERTY] = g_param_spec_boxed ("foreground", "foreground", "foreground", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY, he_application_properties[HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY] = g_param_spec_boxed ("accent-foreground", "accent-foreground", "accent-foreground", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
he_application_instance_init (HeApplication * self,
                              gpointer klass)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
	HeDesktop* _tmp5_;
	self->priv = he_application_get_instance_private (self);
	self->priv->default_dark_accent = (HeColorRGBColor) {0.7450 * 255, 0.6270 * 255, 0.8590 * 255};
	self->priv->default_light_accent = (HeColorRGBColor) {0.5490 * 255, 0.3370 * 255, 0.7490 * 255};
	_tmp0_ = gtk_css_provider_new ();
	self->priv->light = _tmp0_;
	_tmp1_ = gtk_css_provider_new ();
	self->priv->dark = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	self->priv->accent = _tmp2_;
	_tmp3_ = gtk_css_provider_new ();
	self->priv->user_base = _tmp3_;
	_tmp4_ = gtk_css_provider_new ();
	self->priv->user_dark = _tmp4_;
	_tmp5_ = he_desktop_new ();
	self->priv->desktop = _tmp5_;
}

static void
he_application_finalize (GObject * obj)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION, HeApplication);
	_he_color_rgb_color_free0 (self->priv->_default_accent_color);
	_he_color_rgb_color_free0 (self->priv->_derived_card_bg);
	_g_object_unref0 (self->priv->light);
	_g_object_unref0 (self->priv->dark);
	_g_object_unref0 (self->priv->accent);
	_g_object_unref0 (self->priv->user_base);
	_g_object_unref0 (self->priv->user_dark);
	_g_object_unref0 (self->priv->desktop);
	_he_color_rgb_color_free0 (self->priv->_accent_color);
	_he_color_rgb_color_free0 (self->priv->_foreground);
	_he_color_rgb_color_free0 (self->priv->_accent_foreground);
	G_OBJECT_CLASS (he_application_parent_class)->finalize (obj);
}

/**
* An application.
*/
static GType
he_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplication), 0, (GInstanceInitFunc) he_application_instance_init, NULL };
	GType he_application_type_id;
	he_application_type_id = g_type_register_static (gtk_application_get_type (), "HeApplication", &g_define_type_info, 0);
	HeApplication_private_offset = g_type_add_instance_private (he_application_type_id, sizeof (HeApplicationPrivate));
	return he_application_type_id;
}

GType
he_application_get_type (void)
{
	static volatile gsize he_application_type_id__once = 0;
	if (g_once_init_enter (&he_application_type_id__once)) {
		GType he_application_type_id;
		he_application_type_id = he_application_get_type_once ();
		g_once_init_leave (&he_application_type_id__once, he_application_type_id);
	}
	return he_application_type_id__once;
}

static void
_vala_he_application_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
	switch (property_id) {
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
		{
			HeColorRGBColor* boxed;
			boxed = he_application_get_default_accent_color (self);
			g_value_set_boxed (value, boxed);
		}
		break;
		case HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY:
		g_value_set_double (value, he_application_get_default_font_weight (self));
		break;
		case HE_APPLICATION_ACCENT_COLOR_PROPERTY:
		{
			HeColorRGBColor boxed;
			he_application_get_accent_color (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case HE_APPLICATION_FOREGROUND_PROPERTY:
		{
			HeColorRGBColor boxed;
			he_application_get_foreground (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY:
		{
			HeColorRGBColor boxed;
			he_application_get_accent_foreground (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_application_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
	switch (property_id) {
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
		he_application_set_default_accent_color (self, g_value_get_boxed (value));
		break;
		case HE_APPLICATION_DEFAULT_FONT_WEIGHT_PROPERTY:
		he_application_set_default_font_weight (self, g_value_get_double (value));
		break;
		case HE_APPLICATION_ACCENT_COLOR_PROPERTY:
		he_application_set_accent_color (self, g_value_get_boxed (value));
		break;
		case HE_APPLICATION_FOREGROUND_PROPERTY:
		he_application_set_foreground (self, g_value_get_boxed (value));
		break;
		case HE_APPLICATION_ACCENT_FOREGROUND_PROPERTY:
		he_application_set_accent_foreground (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

