/* Avatar.c generated by valac 0.56.3, the Vala compiler
 * generated from Avatar.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

enum  {
	HE_AVATAR_0_PROPERTY,
	HE_AVATAR_SIZE_PROPERTY,
	HE_AVATAR_TEXT_PROPERTY,
	HE_AVATAR_IMAGE_PROPERTY,
	HE_AVATAR_NUM_PROPERTIES
};
static GParamSpec* he_avatar_properties[HE_AVATAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeAvatarPrivate {
	gchar* _image;
	gint _size;
	gchar* _text;
	GtkImage* img;
	GtkImage* img_blur;
	GtkLabel* label;
};

static gint HeAvatar_private_offset;
static gpointer he_avatar_parent_class = NULL;

static gchar* he_avatar_extract_initials (HeAvatar* self,
                                   const gchar* t);
static GObject * he_avatar_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void he_avatar_finalize (GObject * obj);
static GType he_avatar_get_type_once (void);
static void _vala_he_avatar_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_avatar_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_avatar_get_instance_private (HeAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, HeAvatar_private_offset);
}

gint
he_avatar_get_size (HeAvatar* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_size;
	return result;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
he_avatar_set_size (HeAvatar* self,
                    gint value)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkCssProvider* css_provider_label = NULL;
	GtkCssProvider* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_ = 0;
	guint8* _tmp7_;
	gint _tmp7__length1;
	GtkStyleContext* context_label = NULL;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	g_return_if_fail (self != NULL);
	self->priv->_size = value;
	gtk_widget_set_size_request ((GtkWidget*) self, value, value);
	_tmp0_ = self->priv->img;
	gtk_image_set_pixel_size (_tmp0_, value);
	_tmp1_ = self->priv->img_blur;
	gtk_image_set_pixel_size (_tmp1_, value);
	_tmp2_ = gtk_css_provider_new ();
	css_provider_label = _tmp2_;
	_tmp3_ = g_strdup_printf ("\n" \
"                .avatar-label {\n" \
"                    font-size: %0.2fpx;\n" \
"                    font-weight: 700;\n" \
"                    color: @accent_fg_color;\n" \
"                }\n" \
"            ", (self->priv->_size / 16) * 7.5);
	_tmp4_ = _tmp3_;
	_tmp5_ = string_get_data (_tmp4_, &_tmp6_);
	_tmp5__length1 = _tmp6_;
	_tmp7_ = _tmp5_;
	_tmp7__length1 = _tmp5__length1;
	gtk_css_provider_load_from_data (css_provider_label, _tmp7_, (gssize) _tmp7__length1);
	_g_free0 (_tmp4_);
	_tmp8_ = self->priv->label;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	_tmp10_ = _g_object_ref0 (_tmp9_);
	context_label = _tmp10_;
	gtk_style_context_add_provider (context_label, (GtkStyleProvider*) css_provider_label, (guint) 69);
	_g_object_unref0 (context_label);
	_g_object_unref0 (css_provider_label);
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY]);
}

const gchar*
he_avatar_get_text (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text;
	result = _tmp0_;
	return result;
}

void
he_avatar_set_text (HeAvatar* self,
                    const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_text);
	self->priv->_text = _tmp0_;
	if (value != NULL) {
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->label;
		_tmp2_ = he_avatar_extract_initials (self, value);
		_tmp3_ = _tmp2_;
		gtk_label_set_label (_tmp1_, _tmp3_);
		_g_free0 (_tmp3_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY]);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
he_avatar_extract_initials (HeAvatar* self,
                            const gchar* t)
{
	gchar* ret = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (t != NULL, NULL);
	_tmp0_ = g_strdup ("");
	ret = _tmp0_;
	_tmp1_ = strlen (t);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		_g_free0 (ret);
		return result;
	}
	_tmp4_ = ret;
	_tmp5_ = g_strdup_printf ("%c", string_get (t, (glong) 0));
	_tmp6_ = _tmp5_;
	_tmp7_ = g_utf8_strup (_tmp6_, (gssize) -1);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
	_g_free0 (ret);
	ret = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				gint _tmp12_;
				gint _tmp13_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = i;
					i = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				_tmp12_ = strlen (t);
				_tmp13_ = _tmp12_;
				if (!(i < (_tmp13_ - 1))) {
					break;
				}
				if (string_get (t, (glong) i) == ' ') {
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					_tmp14_ = ret;
					_tmp15_ = g_strdup_printf ("%c", string_get (t, (glong) (i + 1)));
					_tmp16_ = _tmp15_;
					_tmp17_ = g_utf8_strup (_tmp16_, (gssize) -1);
					_tmp18_ = _tmp17_;
					_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
					_g_free0 (ret);
					ret = _tmp19_;
					_g_free0 (_tmp18_);
					_g_free0 (_tmp16_);
				}
			}
		}
	}
	result = ret;
	return result;
}

const gchar*
he_avatar_get_image (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image;
	result = _tmp0_;
	return result;
}

void
he_avatar_set_image (HeAvatar* self,
                     const gchar* value)
{
	gchar* _tmp0_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_ = 0;
	guint8* _tmp10_;
	gint _tmp10__length1;
	GtkStyleContext* context = NULL;
	GtkImage* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkCssProvider* _tmp15_;
	GtkCssProvider* css_provider_blur = NULL;
	GtkCssProvider* _tmp16_;
	GtkStyleContext* context_blur = NULL;
	GtkImage* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkCssProvider* _tmp34_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_image);
	self->priv->_image = _tmp0_;
	if (value != NULL) {
		GtkLabel* _tmp1_;
		_tmp1_ = self->priv->label;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
	} else {
		GtkLabel* _tmp2_;
		_tmp2_ = self->priv->label;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	}
	_tmp3_ = gtk_css_provider_new ();
	css_provider = _tmp3_;
	_tmp4_ = css_provider;
	_tmp5_ = self->priv->_image;
	_tmp6_ = g_strdup_printf ("\n" \
"            .avatar {\n" \
"                background-image: url('%s');\n" \
"                background-size: cover;\n" \
"                background-color: @accent_bg_color;\n" \
"                border-radius: 999px;\n" \
"                box-shadow: inset 0 0 0 1px @borders;\n" \
"            }\n" \
"            ", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = string_get_data (_tmp7_, &_tmp9_);
	_tmp8__length1 = _tmp9_;
	_tmp10_ = _tmp8_;
	_tmp10__length1 = _tmp8__length1;
	gtk_css_provider_load_from_data (_tmp4_, _tmp10_, (gssize) _tmp10__length1);
	_g_free0 (_tmp7_);
	_tmp11_ = self->priv->img;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	_tmp13_ = _g_object_ref0 (_tmp12_);
	context = _tmp13_;
	_tmp14_ = context;
	_tmp15_ = css_provider;
	gtk_style_context_add_provider (_tmp14_, (GtkStyleProvider*) _tmp15_, (guint) 69);
	_tmp16_ = gtk_css_provider_new ();
	css_provider_blur = _tmp16_;
	if (self->priv->_size <= 32) {
		GtkCssProvider* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		guint8* _tmp21_;
		gint _tmp21__length1;
		gint _tmp22_ = 0;
		guint8* _tmp23_;
		gint _tmp23__length1;
		_tmp17_ = css_provider_blur;
		_tmp18_ = self->priv->_image;
		_tmp19_ = g_strdup_printf ("\n" \
"                .avatar-blur {\n" \
"                    background-image: url('%s');\n" \
"                    background-size: cover;\n" \
"                    background-color: @accent_bg_color;\n" \
"                    border-radius: 999px;\n" \
"                    box-shadow: inset 0 0 0 1px @borders;\n" \
"                    filter: drop-shadow(0px 0px 1px @borders);\n" \
"                }\n" \
"                ", _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = string_get_data (_tmp20_, &_tmp22_);
		_tmp21__length1 = _tmp22_;
		_tmp23_ = _tmp21_;
		_tmp23__length1 = _tmp21__length1;
		gtk_css_provider_load_from_data (_tmp17_, _tmp23_, (gssize) _tmp23__length1);
		_g_free0 (_tmp20_);
	} else {
		GtkCssProvider* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		guint8* _tmp28_;
		gint _tmp28__length1;
		gint _tmp29_ = 0;
		guint8* _tmp30_;
		gint _tmp30__length1;
		_tmp24_ = css_provider_blur;
		_tmp25_ = self->priv->_image;
		_tmp26_ = g_strdup_printf ("\n" \
"                .avatar-blur {\n" \
"                    background-image: url('%s');\n" \
"                    background-size: cover;\n" \
"                    background-color: @accent_bg_color;\n" \
"                    border-radius: 999px;\n" \
"                    box-shadow: inset 0 0 0 1px @borders;\n" \
"                    filter: drop-shadow(0px 0px 1px @borders) blur(2px" \
");\n" \
"                }\n" \
"                ", _tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = string_get_data (_tmp27_, &_tmp29_);
		_tmp28__length1 = _tmp29_;
		_tmp30_ = _tmp28_;
		_tmp30__length1 = _tmp28__length1;
		gtk_css_provider_load_from_data (_tmp24_, _tmp30_, (gssize) _tmp30__length1);
		_g_free0 (_tmp27_);
	}
	_tmp31_ = self->priv->img_blur;
	_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) _tmp31_);
	_tmp33_ = _g_object_ref0 (_tmp32_);
	context_blur = _tmp33_;
	_tmp34_ = css_provider_blur;
	gtk_style_context_add_provider (context_blur, (GtkStyleProvider*) _tmp34_, (guint) 69);
	_g_object_unref0 (context_blur);
	_g_object_unref0 (css_provider_blur);
	_g_object_unref0 (context);
	_g_object_unref0 (css_provider);
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY]);
}

/**
    * Creates a new Avatar.
    * @param image The image to display
    *
    * @since 1.1
    */
HeAvatar*
he_avatar_construct (GType object_type,
                     gint size,
                     const gchar* image,
                     const gchar* text)
{
	HeAvatar * self = NULL;
	self = (HeAvatar*) he_bin_construct (object_type);
	he_avatar_set_image (self, image);
	he_avatar_set_text (self, text);
	he_avatar_set_size (self, size);
	return self;
}

HeAvatar*
he_avatar_new (gint size,
               const gchar* image,
               const gchar* text)
{
	return he_avatar_construct (HE_TYPE_AVATAR, size, image, text);
}

static GObject *
he_avatar_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAvatar * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkOverlay* ioverlay = NULL;
	GtkOverlay* _tmp11_;
	GtkOverlay* _tmp12_;
	GtkImage* _tmp13_;
	GtkOverlay* _tmp14_;
	GtkImage* _tmp15_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkOverlay* _tmp19_;
	GtkLabel* _tmp20_;
	GtkOverlay* _tmp21_;
	parent_class = G_OBJECT_CLASS (he_avatar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
	_tmp0_ = self->priv->img;
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "avatar");
	_tmp1_ = self->priv->img;
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = self->priv->img;
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = self->priv->img_blur;
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "avatar-blur");
	_tmp4_ = self->priv->img_blur;
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	_tmp5_ = self->priv->img_blur;
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
	_tmp6_ = self->priv->label;
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
	_tmp7_ = self->priv->label;
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = self->priv->label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "dim-label");
	_tmp9_ = self->priv->label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "avatar-label");
	_tmp10_ = self->priv->label;
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
	_tmp11_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp11_);
	ioverlay = _tmp11_;
	_tmp12_ = ioverlay;
	_tmp13_ = self->priv->img_blur;
	gtk_overlay_set_child (_tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = ioverlay;
	_tmp15_ = self->priv->img;
	gtk_overlay_add_overlay (_tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp16_);
	overlay = _tmp16_;
	_tmp17_ = overlay;
	_tmp18_ = ioverlay;
	gtk_overlay_set_child (_tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = overlay;
	_tmp20_ = self->priv->label;
	gtk_overlay_add_overlay (_tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = overlay;
	gtk_widget_set_parent ((GtkWidget*) _tmp21_, (GtkWidget*) self);
	_g_object_unref0 (overlay);
	_g_object_unref0 (ioverlay);
	return obj;
}

static void
he_avatar_class_init (HeAvatarClass * klass,
                      gpointer klass_data)
{
	he_avatar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeAvatar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_avatar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_avatar_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_avatar_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_avatar_finalize;
	/**
	    * The size of the avatar.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_SIZE_PROPERTY, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	    * The text of the avatar.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_TEXT_PROPERTY, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	    * The image of the avatar.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_IMAGE_PROPERTY, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_avatar_instance_init (HeAvatar * self,
                         gpointer klass)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* _tmp2_;
	self->priv = he_avatar_get_instance_private (self);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->img = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->img_blur = _tmp1_;
	_tmp2_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp2_);
	self->priv->label = _tmp2_;
}

static void
he_avatar_finalize (GObject * obj)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
	_g_free0 (self->priv->_image);
	_g_free0 (self->priv->_text);
	_g_object_unref0 (self->priv->img);
	_g_object_unref0 (self->priv->img_blur);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (he_avatar_parent_class)->finalize (obj);
}

/**
* An Avatar is an element that displays an image that represents a person.
*/
static GType
he_avatar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAvatar), 0, (GInstanceInitFunc) he_avatar_instance_init, NULL };
	GType he_avatar_type_id;
	he_avatar_type_id = g_type_register_static (HE_TYPE_BIN, "HeAvatar", &g_define_type_info, 0);
	HeAvatar_private_offset = g_type_add_instance_private (he_avatar_type_id, sizeof (HeAvatarPrivate));
	return he_avatar_type_id;
}

GType
he_avatar_get_type (void)
{
	static volatile gsize he_avatar_type_id__once = 0;
	if (g_once_init_enter (&he_avatar_type_id__once)) {
		GType he_avatar_type_id;
		he_avatar_type_id = he_avatar_get_type_once ();
		g_once_init_leave (&he_avatar_type_id__once, he_avatar_type_id);
	}
	return he_avatar_type_id__once;
}

static void
_vala_he_avatar_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
	switch (property_id) {
		case HE_AVATAR_SIZE_PROPERTY:
		g_value_set_int (value, he_avatar_get_size (self));
		break;
		case HE_AVATAR_TEXT_PROPERTY:
		g_value_set_string (value, he_avatar_get_text (self));
		break;
		case HE_AVATAR_IMAGE_PROPERTY:
		g_value_set_string (value, he_avatar_get_image (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_avatar_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
	switch (property_id) {
		case HE_AVATAR_SIZE_PROPERTY:
		he_avatar_set_size (self, g_value_get_int (value));
		break;
		case HE_AVATAR_TEXT_PROPERTY:
		he_avatar_set_text (self, g_value_get_string (value));
		break;
		case HE_AVATAR_IMAGE_PROPERTY:
		he_avatar_set_image (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

